/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "sg.y"


/*
 * ufdbGuard is copyrighted (C) 2005-2016 by URLfilterDB with all rights reserved.
 *
 * Parts of the ufdbGuard daemon are based on squidGuard.
 * squidGuard is copyrighted (C) 1998 by
 * ElTele st AS, Oslo, Norway, with all rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License (version 2) as
 * published by the Free Software Foundation.  It is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License (GPL) for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * (GPL2) along with this program.
 */

#define YYMALLOC  ufdbMalloc
#define YYFREE    ufdbFree

#define UFDB_LOG_USER_QUOTA   0   /* TODO remove */

#undef UFDB_DEBUG_ACL_ACCESS

#include "ufdb.h"
#include "sg.h"
#include "ufdblib.h"
#include "ufdbdb.h"
#include "ufdbchkport.h"

#define UFDB_DEBUG 0

#ifdef UFDB_DEBUG
#undef YYDEBUG
#define YYDEBUG 1
#endif

#define UFDB_TIME_DEBUG 0

#include <pthread.h>
#include <sys/types.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <netdb.h>
#include <grp.h>
#include <syslog.h>
#include <signal.h>
#include <sched.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <unistd.h>


FILE * yyin;
FILE * yyout;
int    lineno;

extern struct ufdbSetting * lastSetting;
extern struct ufdbSetting * Setting;

extern struct Source * lastSource;

extern struct Category * lastCat;
extern struct Category * Cat;

extern struct sgRewrite * lastRewrite;
extern struct sgRewrite * Rewrite;
extern struct ufdbRegExp *  lastRewriteRegExec;

extern struct ufdbTime * lastTime;
extern struct ufdbTime * TimeList;

extern struct LogFile * globalLogFile;

extern struct LogFileStat * lastLogFileStat;
extern struct LogFileStat * LogFileStat;

extern struct TimeElement * lastTimeElement;
extern struct TimeElement * TimeElement;

extern struct Acl * lastAcl;
extern struct Acl * defaultAcl;
extern struct Aclcategory * lastAclcategory;
 
extern struct ufdbRegExp * lastRegExpDest;

extern int    httpsConnectionCacheSize;

extern int    globalDebugTimeDelta;

static int   numTimeElements = 0;
static int * TimeElementsEvents = NULL;

static int   time_switch = 0;
static int   date_switch = 0;

static void setRefreshUserlist( int nmin );
static void setRefreshDomainlist( int nmin );
static void ufdbSourceGroup( int groupType, char * groupName );
static void ufdbSourceUserQuota( const char * seconds, const char * sporadic, const char * renew );
void sgAclSetValue( const char * what, char * value, int allowed );
void sgIp( const char * name );
void ufdbFreeDomainDb( struct sgDb * dbp );


/* Line 371 of yacc.c  */
#line 178 "y.tab.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ADMINISTRATOR = 258,
     QSTRING = 259,
     CHECK_PROXY_TUNNELS = 260,
     QUEUE_CHECKS = 261,
     AGGRESSIVE = 262,
     LOG_ONLY = 263,
     ON = 264,
     OFF = 265,
     CHAR_MINUS = 266,
     CHAR_I = 267,
     CHAR_EXCLAMATION = 268,
     IGNORECASE = 269,
     COMMA = 270,
     EQUAL = 271,
     PORT = 272,
     HTTP_SERVER = 273,
     INTERFACE = 274,
     IMAGES = 275,
     HTTPS_PROHIBIT_INSECURE_SSLV2 = 276,
     HTTPS_PROHIBIT_INSECURE_SSLV3 = 277,
     HTTPS_CONNECTION_CACHE_SIZE = 278,
     IDENTIFIER = 279,
     WORD = 280,
     END = 281,
     START_BRACKET = 282,
     STOP_BRACKET = 283,
     WEEKDAY = 284,
     CATEGORY = 285,
     REWRITE = 286,
     ACL = 287,
     CPUS = 288,
     TIME = 289,
     TVAL = 290,
     DVAL = 291,
     DVALCRON = 292,
     BLOCK_BUMPED_CONNECT = 293,
     EVALUATE_AND = 294,
     EVALUATE_OR = 295,
     SOURCE = 296,
     CIDR = 297,
     IPCLASS = 298,
     CONTINUE = 299,
     IPADDR = 300,
     IPV6ADDR = 301,
     IPV6NET = 302,
     DBHOME = 303,
     DOMAINLIST = 304,
     EXECDOMAINLIST = 305,
     REFRESHDOMAINLIST = 306,
     URLLIST = 307,
     EXPRESSIONLIST = 308,
     CACERTS = 309,
     CACERTSDIR = 310,
     IPLIST = 311,
     DOMAIN = 312,
     UNIX = 313,
     LDAP = 314,
     USER = 315,
     USERLIST = 316,
     EXECUSERLIST = 317,
     REFRESHUSERLIST = 318,
     USERQUOTA = 319,
     GROUP = 320,
     IP = 321,
     NL = 322,
     NUMBER = 323,
     NUMBERS = 324,
     PASS = 325,
     REDIRECT = 326,
     SUBST = 327,
     CHAR = 328,
     MINUTELY = 329,
     HOURLY = 330,
     DAILY = 331,
     WEEKLY = 332,
     DATE = 333,
     REDIRECT_FATAL_ERROR = 334,
     REDIRECT_LOADING_DATABASE = 335,
     REDIRECT_HTTPS = 336,
     REDIRECT_BUMPED_HTTPS = 337,
     WITHIN = 338,
     OUTSIDE = 339,
     ELSE = 340,
     ANONYMOUS = 341,
     SPORADIC = 342,
     PIDFILE = 343,
     LOGFILE = 344,
     LOGDIR = 345,
     LOGPASS = 346,
     LOGBLOCK = 347,
     LOGALL = 348,
     LOGALL_HTTPD = 349,
     MAIL_SERVER = 350,
     MY_HOSTNAME = 351,
     ADMIN_EMAIL = 352,
     SENDER_EMAIL = 353,
     EXTERNAL_STATUS_COMMAND = 354,
     TOKEN_ALLOW = 355,
     TOKEN_DENY = 356,
     YOUTUBE_EDUFILTER = 357,
     YOUTUBE_EDUFILTER_ID = 358,
     ALLOW_GOOGLE_HTTPS_USING_IP = 359,
     URL_LOOKUP_RESULT_DB_RELOAD = 360,
     URL_LOOKUP_RESULT_FATAL_ERROR = 361,
     URL_LOOKUP_DELAY_DB_RELOAD = 362,
     OPTION = 363,
     UFDB_SHOW_URL_DETAILS = 364,
     SQUID_VERSION = 365,
     SQUID_USES_SSL_BUMP = 366,
     UPLOAD_CRASH_REPORTS = 367,
     LOOKUP_REVERSE_IP = 368,
     USE_IPV6_ON_WAN = 369,
     STRIP_DOMAIN_FROM_USERNAME = 370,
     UFDB_DEBUG_FILTER = 371,
     UFDB_DEBUG_SKYPE_PROBES = 372,
     UFDB_DEBUG_GTALK_PROBES = 373,
     UFDB_DEBUG_YAHOOMSG_PROBES = 374,
     UFDB_DEBUG_AIM_PROBES = 375,
     UFDB_DEBUG_FBCHAT_PROBES = 376,
     UFDB_DEBUG_CITRIXONLINE_PROBES = 377,
     UFDB_EXPRESSION_OPTIMISATION = 378,
     UFDB_EXPRESSION_DEBUG = 379,
     UFDB_DEBUG_EXTERNAL_SCRIPTS = 380,
     UFDB_NUM_WORKER_THREADS = 381,
     ENFORCE_HTTPS_WITH_HOSTNAME = 382,
     ENFORCE_HTTPS_OFFICAL_CERTIFICATE = 383,
     ALLOW_SKYPE_OVER_HTTPS = 384,
     ALLOW_UNKNOWN_PROTOCOL_OVER_HTTPS = 385,
     ALLOW_GTALK_OVER_HTTPS = 386,
     ALLOW_YAHOOMSG_OVER_HTTPS = 387,
     ALLOW_AIM_OVER_HTTPS = 388,
     ALLOW_FBCHAT_OVER_HTTPS = 389,
     ALLOW_CITRIXONLINE_OVER_HTTPS = 390,
     ALLOW_ANYDESK_OVER_HTTPS = 391,
     ALLOW_TEAMVIEWER_OVER_HTTPS = 392,
     ANALYSE_UNCATEGORISED = 393,
     LOG_UNCATEGORISED_URLS = 394,
     UPLOAD_STATS = 395,
     SAFE_SEARCH = 396,
     MAX_LOGFILE_SIZE = 397
   };
#endif
/* Tokens.  */
#define ADMINISTRATOR 258
#define QSTRING 259
#define CHECK_PROXY_TUNNELS 260
#define QUEUE_CHECKS 261
#define AGGRESSIVE 262
#define LOG_ONLY 263
#define ON 264
#define OFF 265
#define CHAR_MINUS 266
#define CHAR_I 267
#define CHAR_EXCLAMATION 268
#define IGNORECASE 269
#define COMMA 270
#define EQUAL 271
#define PORT 272
#define HTTP_SERVER 273
#define INTERFACE 274
#define IMAGES 275
#define HTTPS_PROHIBIT_INSECURE_SSLV2 276
#define HTTPS_PROHIBIT_INSECURE_SSLV3 277
#define HTTPS_CONNECTION_CACHE_SIZE 278
#define IDENTIFIER 279
#define WORD 280
#define END 281
#define START_BRACKET 282
#define STOP_BRACKET 283
#define WEEKDAY 284
#define CATEGORY 285
#define REWRITE 286
#define ACL 287
#define CPUS 288
#define TIME 289
#define TVAL 290
#define DVAL 291
#define DVALCRON 292
#define BLOCK_BUMPED_CONNECT 293
#define EVALUATE_AND 294
#define EVALUATE_OR 295
#define SOURCE 296
#define CIDR 297
#define IPCLASS 298
#define CONTINUE 299
#define IPADDR 300
#define IPV6ADDR 301
#define IPV6NET 302
#define DBHOME 303
#define DOMAINLIST 304
#define EXECDOMAINLIST 305
#define REFRESHDOMAINLIST 306
#define URLLIST 307
#define EXPRESSIONLIST 308
#define CACERTS 309
#define CACERTSDIR 310
#define IPLIST 311
#define DOMAIN 312
#define UNIX 313
#define LDAP 314
#define USER 315
#define USERLIST 316
#define EXECUSERLIST 317
#define REFRESHUSERLIST 318
#define USERQUOTA 319
#define GROUP 320
#define IP 321
#define NL 322
#define NUMBER 323
#define NUMBERS 324
#define PASS 325
#define REDIRECT 326
#define SUBST 327
#define CHAR 328
#define MINUTELY 329
#define HOURLY 330
#define DAILY 331
#define WEEKLY 332
#define DATE 333
#define REDIRECT_FATAL_ERROR 334
#define REDIRECT_LOADING_DATABASE 335
#define REDIRECT_HTTPS 336
#define REDIRECT_BUMPED_HTTPS 337
#define WITHIN 338
#define OUTSIDE 339
#define ELSE 340
#define ANONYMOUS 341
#define SPORADIC 342
#define PIDFILE 343
#define LOGFILE 344
#define LOGDIR 345
#define LOGPASS 346
#define LOGBLOCK 347
#define LOGALL 348
#define LOGALL_HTTPD 349
#define MAIL_SERVER 350
#define MY_HOSTNAME 351
#define ADMIN_EMAIL 352
#define SENDER_EMAIL 353
#define EXTERNAL_STATUS_COMMAND 354
#define TOKEN_ALLOW 355
#define TOKEN_DENY 356
#define YOUTUBE_EDUFILTER 357
#define YOUTUBE_EDUFILTER_ID 358
#define ALLOW_GOOGLE_HTTPS_USING_IP 359
#define URL_LOOKUP_RESULT_DB_RELOAD 360
#define URL_LOOKUP_RESULT_FATAL_ERROR 361
#define URL_LOOKUP_DELAY_DB_RELOAD 362
#define OPTION 363
#define UFDB_SHOW_URL_DETAILS 364
#define SQUID_VERSION 365
#define SQUID_USES_SSL_BUMP 366
#define UPLOAD_CRASH_REPORTS 367
#define LOOKUP_REVERSE_IP 368
#define USE_IPV6_ON_WAN 369
#define STRIP_DOMAIN_FROM_USERNAME 370
#define UFDB_DEBUG_FILTER 371
#define UFDB_DEBUG_SKYPE_PROBES 372
#define UFDB_DEBUG_GTALK_PROBES 373
#define UFDB_DEBUG_YAHOOMSG_PROBES 374
#define UFDB_DEBUG_AIM_PROBES 375
#define UFDB_DEBUG_FBCHAT_PROBES 376
#define UFDB_DEBUG_CITRIXONLINE_PROBES 377
#define UFDB_EXPRESSION_OPTIMISATION 378
#define UFDB_EXPRESSION_DEBUG 379
#define UFDB_DEBUG_EXTERNAL_SCRIPTS 380
#define UFDB_NUM_WORKER_THREADS 381
#define ENFORCE_HTTPS_WITH_HOSTNAME 382
#define ENFORCE_HTTPS_OFFICAL_CERTIFICATE 383
#define ALLOW_SKYPE_OVER_HTTPS 384
#define ALLOW_UNKNOWN_PROTOCOL_OVER_HTTPS 385
#define ALLOW_GTALK_OVER_HTTPS 386
#define ALLOW_YAHOOMSG_OVER_HTTPS 387
#define ALLOW_AIM_OVER_HTTPS 388
#define ALLOW_FBCHAT_OVER_HTTPS 389
#define ALLOW_CITRIXONLINE_OVER_HTTPS 390
#define ALLOW_ANYDESK_OVER_HTTPS 391
#define ALLOW_TEAMVIEWER_OVER_HTTPS 392
#define ANALYSE_UNCATEGORISED 393
#define LOG_UNCATEGORISED_URLS 394
#define UPLOAD_STATS 395
#define SAFE_SEARCH 396
#define MAX_LOGFILE_SIZE 397



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 111 "sg.y"

  char * string;
  char * tval;
  char * dval;
  char * dvalcron;
  int    integer;


/* Line 387 of yacc.c  */
#line 514 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE yylval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 542 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   551

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  143
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  112
/* YYNRULES -- Number of rules.  */
#define YYNRULES  324
/* YYNRULES -- Number of states.  */
#define YYNSTATES  478

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   397

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,     9,    12,    14,    16,    18,
      20,    22,    25,    28,    31,    34,    37,    40,    43,    46,
      49,    52,    55,    58,    61,    63,    65,    67,    69,    72,
      75,    78,    81,    84,    87,    90,    93,    96,    99,   102,
     105,   108,   111,   114,   117,   120,   123,   126,   129,   132,
     135,   138,   141,   144,   147,   150,   153,   156,   159,   162,
     165,   168,   171,   174,   177,   180,   183,   186,   189,   192,
     195,   198,   201,   204,   207,   210,   213,   216,   219,   223,
     227,   231,   235,   239,   243,   247,   249,   254,   257,   260,
     263,   266,   269,   274,   275,   278,   281,   284,   287,   290,
     293,   296,   299,   302,   305,   308,   312,   316,   320,   324,
     327,   330,   333,   336,   339,   342,   345,   348,   351,   354,
     358,   362,   366,   369,   373,   376,   380,   384,   388,   392,
     396,   400,   404,   408,   412,   416,   420,   424,   428,   432,
     435,   438,   441,   446,   447,   450,   453,   456,   460,   463,
     466,   470,   474,   477,   480,   483,   487,   491,   496,   501,
     506,   511,   514,   517,   520,   522,   524,   527,   530,   534,
     538,   541,   544,   546,   547,   550,   553,   556,   557,   560,
     563,   566,   571,   572,   575,   578,   583,   588,   592,   593,
     602,   603,   606,   609,   612,   615,   618,   621,   625,   629,
     632,   635,   636,   639,   642,   646,   650,   653,   655,   657,
     658,   661,   665,   669,   674,   677,   679,   682,   685,   690,
     691,   694,   696,   699,   702,   706,   710,   713,   716,   719,
     724,   725,   728,   729,   730,   736,   737,   738,   744,   745,
     746,   752,   753,   757,   759,   760,   766,   770,   773,   775,
     780,   784,   787,   789,   791,   793,   795,   797,   798,   801,
     803,   805,   807,   809,   811,   813,   815,   817,   819,   821,
     823,   825,   827,   829,   831,   833,   835,   837,   839,   841,
     843,   845,   847,   849,   851,   853,   855,   857,   859,   861,
     863,   865,   867,   869,   871,   873,   875,   877,   879,   881,
     883,   885,   887,   889,   891,   893,   895,   897,   899,   901,
     903,   905,   907,   909,   911,   913,   915,   917,   919,   921,
     923,   925,   927,   929,   931
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     144,     0,    -1,   253,    -1,    24,    -1,     4,    -1,    23,
      68,    -1,   100,    -1,   101,    -1,     9,    -1,    10,    -1,
       1,    -1,    91,   148,    -1,    92,   148,    -1,    93,   148,
      -1,    94,   148,    -1,   102,   148,    -1,   103,     4,    -1,
     104,   148,    -1,   116,   148,    -1,   116,    68,    -1,   127,
     148,    -1,   128,   148,    -1,    21,   148,    -1,    22,   148,
      -1,    10,    -1,     6,    -1,     7,    -1,     8,    -1,     5,
     161,    -1,     3,     4,    -1,    48,   145,    -1,    48,    25,
      -1,    63,    68,    -1,    51,    68,    -1,   105,   147,    -1,
     106,   147,    -1,   107,   148,    -1,   110,     4,    -1,   126,
      68,    -1,   112,   148,    -1,   113,   148,    -1,   114,   148,
      -1,   111,   148,    -1,   109,   148,    -1,   117,   148,    -1,
     118,   148,    -1,   119,   148,    -1,   120,   148,    -1,   121,
     148,    -1,   122,   148,    -1,   123,   148,    -1,   124,   148,
      -1,   125,   148,    -1,    95,     4,    -1,    96,     4,    -1,
      97,     4,    -1,    98,     4,    -1,    99,     4,    -1,    90,
     145,    -1,    90,    25,    -1,    88,   145,    -1,    88,    25,
      -1,    17,    68,    -1,    19,   145,    -1,    19,    45,    -1,
      33,    68,    -1,    33,    69,    -1,   140,   148,    -1,    81,
       4,    -1,    82,     4,    -1,    80,     4,    -1,    79,     4,
      -1,   139,   148,    -1,   138,   148,    -1,   138,    68,    -1,
     115,   148,    -1,   141,   148,    -1,   142,    68,    -1,    17,
      16,    68,    -1,    19,    16,   145,    -1,    19,    16,    25,
      -1,    19,    16,    45,    -1,    20,    16,   145,    -1,    20,
      16,    25,    -1,   206,    15,   207,    -1,   206,    -1,    18,
      27,   207,    28,    -1,    30,   145,    -1,    30,     7,    -1,
      30,   100,    -1,    30,   101,    -1,    30,     1,    -1,   209,
      27,   211,    28,    -1,    -1,   211,   212,    -1,    49,   145,
      -1,    49,    25,    -1,    49,    11,    -1,    50,   145,    -1,
      52,   145,    -1,    52,    25,    -1,    52,    11,    -1,    53,
     145,    -1,    53,    25,    -1,    53,    11,    -1,    53,    12,
     145,    -1,    53,    12,    25,    -1,    53,    14,   145,    -1,
      53,    14,    25,    -1,    54,   145,    -1,    54,    25,    -1,
      55,   145,    -1,    55,    25,    -1,    71,   145,    -1,    71,
      25,    -1,    31,   145,    -1,    31,    25,    -1,    83,   145,
      -1,    84,   145,    -1,   108,    38,   148,    -1,   108,   141,
     148,    -1,   108,   102,   148,    -1,   108,   127,    -1,   108,
     127,   148,    -1,   108,   128,    -1,   108,   128,   148,    -1,
     108,    21,   148,    -1,   108,    22,   148,    -1,   108,   129,
     148,    -1,   108,   131,   148,    -1,   108,   132,   148,    -1,
     108,   133,   148,    -1,   108,   134,   148,    -1,   108,   135,
     148,    -1,   108,   136,   148,    -1,   108,   137,   148,    -1,
     108,   130,   148,    -1,    89,    86,   145,    -1,    89,    86,
      25,    -1,    89,   145,    -1,    89,    25,    -1,    41,   145,
      -1,   213,    27,   215,    28,    -1,    -1,   215,   216,    -1,
      57,   217,    -1,    60,   218,    -1,    58,    60,   218,    -1,
      61,   145,    -1,    61,    25,    -1,    58,    61,   145,    -1,
      58,    61,    25,    -1,    62,   145,    -1,    65,   145,    -1,
      65,    25,    -1,    58,    65,   145,    -1,    58,    65,    25,
      -1,    64,    68,    68,    75,    -1,    64,    68,    68,    76,
      -1,    64,    68,    68,    77,    -1,    64,    68,    68,    68,
      -1,    66,   229,    -1,    56,   145,    -1,    56,    25,    -1,
      39,    -1,    40,    -1,    83,   145,    -1,    84,   145,    -1,
      89,    86,   145,    -1,    89,    86,    25,    -1,    89,   145,
      -1,    89,    25,    -1,    44,    -1,    -1,   217,   145,    -1,
     217,    25,    -1,   217,    15,    -1,    -1,   218,   145,    -1,
     218,    25,    -1,   218,    15,    -1,    32,    27,   220,    28,
      -1,    -1,   220,   222,    -1,   145,    27,    -1,   145,    83,
     145,    27,    -1,   145,    84,   145,    27,    -1,   221,   224,
      28,    -1,    -1,   221,   224,    28,    85,   223,    27,   224,
      28,    -1,    -1,   224,   225,    -1,    70,   226,    -1,    31,
     145,    -1,    31,    25,    -1,    71,   145,    -1,    71,    25,
      -1,    89,    86,   145,    -1,    89,    86,    25,    -1,    89,
     145,    -1,    89,    25,    -1,    -1,   226,     7,    -1,   226,
     145,    -1,   226,    13,     7,    -1,   226,    13,   145,    -1,
     226,    15,    -1,    42,    -1,    43,    -1,    -1,   229,   230,
      -1,   229,   230,   227,    -1,   229,   230,   228,    -1,   229,
     230,    11,   230,    -1,   229,    15,    -1,    45,    -1,    31,
     145,    -1,    31,    25,    -1,   231,    27,   233,    28,    -1,
      -1,   233,   234,    -1,    72,    -1,    83,   145,    -1,    84,
     145,    -1,    89,    86,   145,    -1,    89,    86,    25,    -1,
      89,   145,    -1,    89,    25,    -1,    34,   145,    -1,   235,
      27,   237,    28,    -1,    -1,   237,   238,    -1,    -1,    -1,
      77,   239,    29,   240,   246,    -1,    -1,    -1,    77,   241,
     145,   242,   246,    -1,    -1,    -1,    77,   243,    25,   244,
     246,    -1,    -1,    78,   245,   248,    -1,     1,    -1,    -1,
     246,   247,   250,    11,   250,    -1,   250,    11,   250,    -1,
     249,   246,    -1,   249,    -1,   249,    11,   249,   246,    -1,
     249,    11,   249,    -1,   251,   246,    -1,   251,    -1,    36,
      -1,    35,    -1,    37,    -1,     1,    -1,    -1,   253,   254,
      -1,   209,    -1,   214,    -1,   210,    -1,   208,    -1,   163,
      -1,   146,    -1,   162,    -1,   149,    -1,   150,    -1,   151,
      -1,   152,    -1,   156,    -1,   157,    -1,   158,    -1,   159,
      -1,   160,    -1,   164,    -1,   191,    -1,   192,    -1,   186,
      -1,   187,    -1,   188,    -1,   189,    -1,   190,    -1,   169,
      -1,   167,    -1,   168,    -1,   170,    -1,   171,    -1,   172,
      -1,   173,    -1,   174,    -1,   175,    -1,   176,    -1,   177,
      -1,   178,    -1,   179,    -1,   180,    -1,   181,    -1,   182,
      -1,   183,    -1,   184,    -1,   165,    -1,   166,    -1,   185,
      -1,   194,    -1,   193,    -1,   195,    -1,   196,    -1,   197,
      -1,   198,    -1,   199,    -1,   200,    -1,   202,    -1,   201,
      -1,   204,    -1,   203,    -1,   153,    -1,   155,    -1,   154,
      -1,   205,    -1,   219,    -1,   232,    -1,   236,    -1,    67,
      -1,   252,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   193,   193,   197,   198,   202,   206,   207,   211,   212,
     213,   217,   221,   225,   229,   233,   237,   241,   245,   246,
     250,   255,   260,   265,   271,   272,   273,   274,   278,   282,
     286,   287,   291,   295,   299,   303,   307,   311,   316,   336,
     341,   346,   351,   356,   360,   364,   368,   372,   376,   380,
     384,   388,   392,   396,   400,   404,   408,   412,   416,   417,
     421,   422,   426,   430,   441,   445,   446,   450,   455,   460,
     465,   470,   475,   482,   487,   495,   502,   507,   519,   520,
     526,   532,   533,   534,   538,   539,   543,   547,   548,   550,
     552,   554,   559,   563,   564,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   612,   614,
     616,   621,   625,   628,   630,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   648,   650,
     652,   654,   655,   656,   657,   658,   659,   660,   661,   663,
     665,   667,   669,   673,   675,   676,   677,   680,   682,   683,
     684,   688,   691,   692,   696,   697,   698,   702,   704,   703,
     708,   710,   714,   715,   716,   717,   718,   719,   721,   723,
     725,   729,   731,   732,   733,   734,   735,   739,   743,   746,
     748,   749,   750,   751,   752,   756,   760,   761,   765,   768,
     770,   775,   776,   777,   778,   779,   780,   781,   786,   790,
     793,   795,   800,   800,   800,   801,   801,   801,   802,   802,
     802,   803,   803,   804,   808,   808,   809,   813,   814,   815,
     816,   817,   818,   821,   824,   827,   831,   834,   835,   839,
     840,   841,   842,   843,   844,   845,   846,   847,   848,   849,
     850,   851,   852,   853,   854,   855,   856,   857,   858,   859,
     860,   861,   862,   863,   864,   865,   866,   867,   868,   869,
     870,   871,   872,   873,   874,   875,   876,   877,   878,   879,
     880,   881,   882,   883,   884,   885,   886,   887,   888,   889,
     890,   891,   892,   893,   894,   895,   896,   897,   898,   899,
     900,   901,   902,   903,   904
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ADMINISTRATOR", "QSTRING",
  "CHECK_PROXY_TUNNELS", "QUEUE_CHECKS", "AGGRESSIVE", "LOG_ONLY", "ON",
  "OFF", "CHAR_MINUS", "CHAR_I", "CHAR_EXCLAMATION", "IGNORECASE", "COMMA",
  "EQUAL", "PORT", "HTTP_SERVER", "INTERFACE", "IMAGES",
  "HTTPS_PROHIBIT_INSECURE_SSLV2", "HTTPS_PROHIBIT_INSECURE_SSLV3",
  "HTTPS_CONNECTION_CACHE_SIZE", "IDENTIFIER", "WORD", "END",
  "START_BRACKET", "STOP_BRACKET", "WEEKDAY", "CATEGORY", "REWRITE", "ACL",
  "CPUS", "TIME", "TVAL", "DVAL", "DVALCRON", "BLOCK_BUMPED_CONNECT",
  "EVALUATE_AND", "EVALUATE_OR", "SOURCE", "CIDR", "IPCLASS", "CONTINUE",
  "IPADDR", "IPV6ADDR", "IPV6NET", "DBHOME", "DOMAINLIST",
  "EXECDOMAINLIST", "REFRESHDOMAINLIST", "URLLIST", "EXPRESSIONLIST",
  "CACERTS", "CACERTSDIR", "IPLIST", "DOMAIN", "UNIX", "LDAP", "USER",
  "USERLIST", "EXECUSERLIST", "REFRESHUSERLIST", "USERQUOTA", "GROUP",
  "IP", "NL", "NUMBER", "NUMBERS", "PASS", "REDIRECT", "SUBST", "CHAR",
  "MINUTELY", "HOURLY", "DAILY", "WEEKLY", "DATE", "REDIRECT_FATAL_ERROR",
  "REDIRECT_LOADING_DATABASE", "REDIRECT_HTTPS", "REDIRECT_BUMPED_HTTPS",
  "WITHIN", "OUTSIDE", "ELSE", "ANONYMOUS", "SPORADIC", "PIDFILE",
  "LOGFILE", "LOGDIR", "LOGPASS", "LOGBLOCK", "LOGALL", "LOGALL_HTTPD",
  "MAIL_SERVER", "MY_HOSTNAME", "ADMIN_EMAIL", "SENDER_EMAIL",
  "EXTERNAL_STATUS_COMMAND", "TOKEN_ALLOW", "TOKEN_DENY",
  "YOUTUBE_EDUFILTER", "YOUTUBE_EDUFILTER_ID",
  "ALLOW_GOOGLE_HTTPS_USING_IP", "URL_LOOKUP_RESULT_DB_RELOAD",
  "URL_LOOKUP_RESULT_FATAL_ERROR", "URL_LOOKUP_DELAY_DB_RELOAD", "OPTION",
  "UFDB_SHOW_URL_DETAILS", "SQUID_VERSION", "SQUID_USES_SSL_BUMP",
  "UPLOAD_CRASH_REPORTS", "LOOKUP_REVERSE_IP", "USE_IPV6_ON_WAN",
  "STRIP_DOMAIN_FROM_USERNAME", "UFDB_DEBUG_FILTER",
  "UFDB_DEBUG_SKYPE_PROBES", "UFDB_DEBUG_GTALK_PROBES",
  "UFDB_DEBUG_YAHOOMSG_PROBES", "UFDB_DEBUG_AIM_PROBES",
  "UFDB_DEBUG_FBCHAT_PROBES", "UFDB_DEBUG_CITRIXONLINE_PROBES",
  "UFDB_EXPRESSION_OPTIMISATION", "UFDB_EXPRESSION_DEBUG",
  "UFDB_DEBUG_EXTERNAL_SCRIPTS", "UFDB_NUM_WORKER_THREADS",
  "ENFORCE_HTTPS_WITH_HOSTNAME", "ENFORCE_HTTPS_OFFICAL_CERTIFICATE",
  "ALLOW_SKYPE_OVER_HTTPS", "ALLOW_UNKNOWN_PROTOCOL_OVER_HTTPS",
  "ALLOW_GTALK_OVER_HTTPS", "ALLOW_YAHOOMSG_OVER_HTTPS",
  "ALLOW_AIM_OVER_HTTPS", "ALLOW_FBCHAT_OVER_HTTPS",
  "ALLOW_CITRIXONLINE_OVER_HTTPS", "ALLOW_ANYDESK_OVER_HTTPS",
  "ALLOW_TEAMVIEWER_OVER_HTTPS", "ANALYSE_UNCATEGORISED",
  "LOG_UNCATEGORISED_URLS", "UPLOAD_STATS", "SAFE_SEARCH",
  "MAX_LOGFILE_SIZE", "$accept", "start", "qidentifier",
  "https_cache_size", "allow_or_deny", "on_or_off", "log_pass",
  "log_block", "log_all", "logall_httpd", "youtube_edufilter",
  "youtube_edufilter_id", "allow_google_https_using_ip", "debug_filter",
  "enforce_https_with_hostname", "enforce_https_offical_certificate",
  "https_prohibit_insecure_sslv2", "https_prohibit_insecure_sslv3",
  "check_proxy_tunnel_option", "check_proxy_tunnels", "admin_spec",
  "dbhome", "refreshuserlist", "refreshdomainlist",
  "url_lookup_result_db_reload", "url_lookup_result_fatal_error",
  "url_lookup_delay_db_reload", "squid_version", "num_worker_threads",
  "upload_crash_reports", "lookup_reverse_ip", "use_ipv6_on_wan",
  "squid_uses_ssl_bump", "ufdb_show_url_details",
  "ufdb_debug_skype_probes", "ufdb_debug_gtalk_probes",
  "ufdb_debug_yahoomsg_probes", "ufdb_debug_aim_probes",
  "ufdb_debug_fbchat_probes", "ufdb_debug_citrixonline_probes",
  "ufdb_expression_optimisation", "ufdb_expression_debug",
  "ufdb_debug_external_scripts", "mail_server", "my_hostname",
  "admin_email", "sender_email", "external_status_command", "logdir",
  "pidfile", "port", "interface", "cpus", "upload_stats", "redirect_https",
  "redirect_bumped_https", "redirect_loading_database",
  "redirect_fatal_error", "log_uncategorised_urls",
  "analyse_uncategorised", "strip_domain_from_username", "safe_search",
  "max_logfile_size", "httpd_option", "httpd_options", "http_server_def",
  "category", "category_block", "category_contents", "category_content",
  "source", "source_block", "source_contents", "source_content", "domain",
  "user", "acl_block", "acl_contents", "acl_header", "acl_content", "$@1",
  "access_contents", "access_content", "access_pass", "cidr", "ipclass",
  "ips", "ip", "rew", "rew_block", "rew_contents", "rew_content", "time",
  "time_block", "time_contents", "time_content", "$@2", "$@3", "$@4",
  "$@5", "$@6", "$@7", "$@8", "ttime", "$@9", "date", "dval", "tval",
  "dvalcron", "an_error", "statements", "statement", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   143,   144,   145,   145,   146,   147,   147,   148,   148,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   156,
     157,   158,   159,   160,   161,   161,   161,   161,   162,   163,
     164,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   191,
     192,   192,   193,   194,   194,   195,   195,   196,   197,   198,
     199,   200,   201,   202,   202,   203,   204,   205,   206,   206,
     206,   206,   206,   206,   207,   207,   208,   209,   209,   209,
     209,   209,   210,   211,   211,   212,   212,   212,   212,   212,
     212,   212,   212,   212,   212,   212,   212,   212,   212,   212,
     212,   212,   212,   212,   212,   212,   212,   212,   212,   212,
     212,   212,   212,   212,   212,   212,   212,   212,   212,   212,
     212,   212,   212,   212,   212,   212,   212,   212,   212,   212,
     212,   213,   214,   215,   215,   216,   216,   216,   216,   216,
     216,   216,   216,   216,   216,   216,   216,   216,   216,   216,
     216,   216,   216,   216,   216,   216,   216,   216,   216,   216,
     216,   216,   216,   217,   217,   217,   217,   218,   218,   218,
     218,   219,   220,   220,   221,   221,   221,   222,   223,   222,
     224,   224,   225,   225,   225,   225,   225,   225,   225,   225,
     225,   226,   226,   226,   226,   226,   226,   227,   228,   229,
     229,   229,   229,   229,   229,   230,   231,   231,   232,   233,
     233,   234,   234,   234,   234,   234,   234,   234,   235,   236,
     237,   237,   239,   240,   238,   241,   242,   238,   243,   244,
     238,   245,   238,   238,   247,   246,   246,   248,   248,   248,
     248,   248,   248,   249,   250,   251,   252,   253,   253,   254,
     254,   254,   254,   254,   254,   254,   254,   254,   254,   254,
     254,   254,   254,   254,   254,   254,   254,   254,   254,   254,
     254,   254,   254,   254,   254,   254,   254,   254,   254,   254,
     254,   254,   254,   254,   254,   254,   254,   254,   254,   254,
     254,   254,   254,   254,   254,   254,   254,   254,   254,   254,
     254,   254,   254,   254,   254,   254,   254,   254,   254,   254,
     254,   254,   254,   254,   254
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     1,     1,     1,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     3,     3,
       3,     3,     3,     3,     3,     1,     4,     2,     2,     2,
       2,     2,     4,     0,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     3,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     3,
       3,     3,     2,     3,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       2,     2,     4,     0,     2,     2,     2,     3,     2,     2,
       3,     3,     2,     2,     2,     3,     3,     4,     4,     4,
       4,     2,     2,     2,     1,     1,     2,     2,     3,     3,
       2,     2,     1,     0,     2,     2,     2,     0,     2,     2,
       2,     4,     0,     2,     2,     4,     4,     3,     0,     8,
       0,     2,     2,     2,     2,     2,     2,     3,     3,     2,
       2,     0,     2,     2,     3,     3,     2,     1,     1,     0,
       2,     3,     3,     4,     2,     1,     2,     2,     4,     0,
       2,     1,     2,     2,     3,     3,     2,     2,     2,     4,
       0,     2,     0,     0,     5,     0,     0,     5,     0,     0,
       5,     0,     3,     1,     0,     5,     3,     2,     1,     4,
       3,     2,     1,     1,     1,     1,     1,     0,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
     257,     0,     0,     1,   256,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   323,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   264,
     266,   267,   268,   269,   316,   318,   317,   270,   271,   272,
     273,   274,   265,   263,   275,   301,   302,   284,   285,   283,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   303,   278,   279,   280,   281,
     282,   276,   277,   305,   304,   306,   307,   308,   309,   310,
     311,   313,   312,   315,   314,   319,   262,   259,   261,     0,
     260,   320,     0,   321,     0,   322,   324,   258,    29,    25,
      26,    27,    24,    28,    62,     0,     4,     3,    64,    63,
      10,     8,     9,    22,    23,     5,    91,    88,    89,    90,
      87,   217,   216,   182,    65,    66,   228,   141,    31,    30,
      33,    32,    71,    70,    68,    69,    61,    60,    59,    58,
      11,    12,    13,    14,    53,    54,    55,    56,    57,    15,
      16,    17,     6,     7,    34,    35,    36,    43,    37,    42,
      39,    40,    41,    75,    19,    18,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    38,    20,    21,    74,    73,
      72,    67,    76,    77,    93,   143,   219,   230,     0,     0,
       0,    85,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    86,   181,     0,   190,   183,    92,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      94,   142,   164,   165,   172,     0,   173,     0,   177,     0,
       0,     0,     0,   209,     0,     0,     0,   144,   218,   221,
       0,     0,     0,   220,   243,   229,   235,   241,   231,    78,
      80,    81,    79,    83,    82,    84,   184,     0,     0,     0,
     116,   115,    97,    96,    95,    98,   101,   100,    99,   104,
       0,     0,   103,   102,   110,   109,   112,   111,   114,   113,
     117,   118,   140,     0,   139,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   163,   162,   145,   177,     0,     0,   146,   149,   148,
     152,     0,   154,   153,   161,   166,   167,   171,     0,   170,
     222,   223,   227,     0,   226,     0,     0,     0,     0,     0,
       0,   187,     0,   201,     0,     0,   191,   106,   105,   108,
     107,   138,   137,   126,   127,   119,   121,   123,   125,   128,
     136,   129,   130,   131,   132,   133,   134,   135,   120,   176,
     175,   174,   147,   151,   150,   156,   155,   180,   179,   178,
       0,   214,   215,   210,   169,   168,   225,   224,   233,   236,
     239,   253,   255,   242,   248,   252,   185,   186,   188,   194,
     193,   192,   196,   195,   200,     0,   199,   160,   157,   158,
     159,     0,   207,   208,   211,   212,     0,     0,     0,     0,
     254,   247,     0,   251,     0,   202,     0,   206,   203,   198,
     197,   213,   234,   237,   240,   250,     0,     0,   190,   204,
     205,   249,     0,   246,     0,     0,   189,   245
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,   409,    69,   194,   153,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,   143,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   231,   232,   126,   127,   128,   234,   260,
     129,   130,   235,   277,   343,   347,   131,   233,   245,   246,
     454,   299,   376,   431,   444,   445,   354,   413,   132,   133,
     236,   283,   134,   135,   237,   288,   365,   446,   366,   447,
     367,   448,   368,   451,   466,   423,   424,   452,   425,   136,
       2,   137
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -329
static const yytype_int16 yypact[] =
{
    -329,    64,    60,  -329,  -329,    -2,   215,     4,    39,    76,
       6,     6,    19,    13,   283,    41,   -57,   112,   112,   334,
      37,    47,  -329,   113,   134,   143,   186,   347,   349,     6,
       6,     6,     6,   199,   203,   211,   225,   246,     6,   253,
       6,    95,    95,     6,     6,   255,     6,     6,     6,     6,
       6,    61,     6,     6,     6,     6,     6,     6,     6,     6,
       6,    57,     6,     6,    66,     6,     6,     6,   151,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,   235,  -329,   237,
    -329,  -329,   241,  -329,   251,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,   234,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,   222,   268,
     275,   280,   266,    98,   366,   396,   121,    68,   228,    85,
     382,   234,  -329,  -329,     1,  -329,  -329,  -329,   421,   279,
     112,   281,   202,   440,   447,   459,   112,   112,     2,   248,
    -329,  -329,  -329,  -329,  -329,   462,  -329,    38,  -329,   464,
     112,   229,   466,  -329,   112,   112,     9,  -329,  -329,  -329,
     112,   112,    49,  -329,  -329,  -329,     0,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,   112,   112,   163,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
     469,   471,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,   473,  -329,     6,     6,     6,     6,   227,
     359,     6,     6,     6,     6,     6,     6,     6,     6,     6,
       6,  -329,  -329,   193,  -329,   477,   488,   337,  -329,  -329,
    -329,   231,  -329,  -329,   -14,  -329,  -329,  -329,   495,  -329,
    -329,  -329,  -329,   499,  -329,   271,   112,   284,   124,   285,
     286,   230,   501,  -329,   503,    82,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,   337,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
      56,  -329,  -329,   101,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,    93,   298,  -329,  -329,  -329,  -329,
    -329,   527,  -329,  -329,  -329,   505,  -329,  -329,  -329,  -329,
    -329,   294,  -329,  -329,  -329,  -329,   298,   298,   298,   304,
    -329,   307,   332,   307,   317,  -329,   185,  -329,  -329,  -329,
    -329,  -329,   307,   307,   307,   298,   298,   298,  -329,  -329,
    -329,   307,   335,  -329,   204,   298,  -329,  -329
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -329,  -329,    -9,  -329,   303,    -8,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,   106,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,    11,  -329,  -329,  -329,  -329,
    -329,  -120,  -329,  -329,  -329,  -329,  -329,   -85,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -328,  -329,  -329,   -82,  -255,  -329,  -329,
    -329,  -329
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -245
static const yytype_int16 yytable[] =
{
     149,   411,   138,   154,   160,   162,   146,   150,   166,   167,
     169,   164,   165,   146,   156,   151,   152,   146,   177,   179,
     157,   180,   181,   182,   183,  -238,   147,   322,   296,  -232,
     189,   412,   191,   147,   357,   196,   197,   147,   199,   200,
     201,   202,   203,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   146,   216,   217,   219,   220,   221,   222,
      -2,     4,   150,     5,     3,     6,   145,   150,   163,   284,
     151,   152,   144,   147,   362,   151,   152,     7,     8,     9,
     146,    10,    11,    12,   297,   298,   146,   155,   323,   146,
      13,    14,    15,    16,    17,   358,   285,   453,   344,   345,
     147,    18,   146,   346,   449,   170,   147,   434,    19,   147,
     290,    20,   441,   158,   159,   171,   146,   172,   462,   463,
     464,   148,   147,    21,   437,   215,   243,    22,   450,   204,
     291,   438,   439,   440,   218,   363,   147,   471,   173,    23,
      24,    25,    26,   442,   443,   286,   287,   174,    27,   278,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
     421,   422,    38,    39,    40,    41,    42,    43,   435,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,   146,
     175,   371,   469,   279,   372,   192,   193,   146,    64,    65,
      66,    67,    68,   184,   280,   281,   146,   185,   399,   147,
     282,   472,   473,   309,   310,   186,   311,   147,   400,   223,
     477,   139,   140,   141,   244,   142,   147,   312,   150,   187,
     292,   294,   476,   373,   374,   372,   151,   152,   238,   301,
     304,   305,   308,   313,   315,   317,   319,   320,   321,   324,
     188,   228,   375,   229,   230,  -122,   342,   190,  -122,   198,
     349,   350,   224,   353,   225,   355,   356,   359,   226,   325,
     326,   360,   361,   364,   373,   374,  -122,  -122,   227,  -122,
    -122,  -122,  -122,   146,   239,   146,   327,   146,   369,   370,
     302,   240,   306,   375,   242,   241,   289,   351,  -122,   410,
     418,   378,   380,   147,   303,   147,   307,   147,   161,   420,
    -122,  -122,   426,   427,   382,   428,  -122,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   450,   401,  -122,   404,   406,   146,   412,
     421,   146,  -244,   467,   468,   195,   475,   295,   474,   415,
     328,   146,   407,   146,   417,   402,   461,   419,   147,   168,
     150,   147,   408,   430,     0,   433,   436,   465,   151,   152,
       0,   147,   176,   147,   178,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   146,  -124,     0,   340,
    -124,     0,     0,     0,   247,     0,     0,   248,     0,     0,
       0,     0,     0,     0,     0,     0,   147,   293,  -124,  -124,
       0,  -124,  -124,  -124,  -124,   249,   250,     0,   251,   252,
     253,   254,   458,     0,   261,   146,   460,     0,     0,     0,
    -124,     0,     0,     0,     0,   262,   263,   255,     0,     0,
     264,     0,  -124,  -124,   146,   147,   300,   470,  -124,   256,
     257,   146,   265,   266,   267,   258,   268,   269,   270,     0,
     271,   272,   273,   146,   147,   314,   146,  -124,   146,     0,
     146,   147,   316,   146,   259,   146,     0,   146,     0,   274,
     275,   146,     0,   147,   318,   276,   147,   341,   147,   348,
     147,   352,   146,   147,   377,   147,   379,   147,   381,   146,
       0,   147,   403,   146,     0,   146,     0,   146,     0,   146,
       0,     0,   147,   405,     0,     0,     0,     0,     0,   147,
     414,     0,     0,   147,   416,   147,   429,   147,   432,   147,
     459,   146,     0,     0,   455,     0,     0,     0,     0,     0,
     456,     0,   457,     0,     0,     0,     0,     0,     0,     0,
       0,   147
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-329)))

#define yytable_value_is_error(Yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       9,    15,     4,    11,    13,    14,     4,     1,    17,    18,
      19,    68,    69,     4,     1,     9,    10,     4,    27,    28,
       7,    29,    30,    31,    32,    25,    24,    25,    27,    29,
      38,    45,    40,    24,    25,    43,    44,    24,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,     4,    62,    63,    64,    65,    66,    67,
       0,     1,     1,     3,     0,     5,    27,     1,    27,     1,
       9,    10,    68,    24,    25,     9,    10,    17,    18,    19,
       4,    21,    22,    23,    83,    84,     4,    68,    86,     4,
      30,    31,    32,    33,    34,    86,    28,   425,    60,    61,
      24,    41,     4,    65,    11,    68,    24,    25,    48,    24,
      25,    51,    11,   100,   101,    68,     4,     4,   446,   447,
     448,    45,    24,    63,    68,    68,    28,    67,    35,    68,
      45,    75,    76,    77,    68,    86,    24,   465,     4,    79,
      80,    81,    82,    42,    43,    77,    78,     4,    88,    28,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
      36,    37,   102,   103,   104,   105,   106,   107,    86,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,     4,
       4,    28,     7,    72,    31,   100,   101,     4,   138,   139,
     140,   141,   142,     4,    83,    84,     4,     4,    15,    24,
      89,   466,   467,    11,    12,     4,    14,    24,    25,    68,
     475,     6,     7,     8,   233,    10,    24,    25,     1,     4,
     239,   240,    28,    70,    71,    31,     9,    10,    16,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
       4,    17,    89,    19,    20,    28,   265,     4,    31,     4,
     269,   270,    27,   272,    27,   274,   275,   276,    27,    21,
      22,   280,   281,   282,    70,    71,    49,    50,    27,    52,
      53,    54,    55,     4,    16,     4,    38,     4,   297,   298,
      11,    16,    11,    89,    28,    15,    68,    68,    71,    68,
      29,   310,   311,    24,    25,    24,    25,    24,    25,    25,
      83,    84,    27,    27,   323,    85,    89,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,    35,   343,   108,   345,   346,     4,    45,
      36,     4,    35,    11,    27,    42,    11,   241,   468,   358,
     102,     4,    15,     4,   363,   344,   441,   366,    24,    25,
       1,    24,    25,   372,    -1,   374,   375,   449,     9,    10,
      -1,    24,    25,    24,    25,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,     4,    28,    -1,   141,
      31,    -1,    -1,    -1,    28,    -1,    -1,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    24,    25,    49,    50,
      -1,    52,    53,    54,    55,    49,    50,    -1,    52,    53,
      54,    55,   431,    -1,    28,     4,   435,    -1,    -1,    -1,
      71,    -1,    -1,    -1,    -1,    39,    40,    71,    -1,    -1,
      44,    -1,    83,    84,     4,    24,    25,   456,    89,    83,
      84,     4,    56,    57,    58,    89,    60,    61,    62,    -1,
      64,    65,    66,     4,    24,    25,     4,   108,     4,    -1,
       4,    24,    25,     4,   108,     4,    -1,     4,    -1,    83,
      84,     4,    -1,    24,    25,    89,    24,    25,    24,    25,
      24,    25,     4,    24,    25,    24,    25,    24,    25,     4,
      -1,    24,    25,     4,    -1,     4,    -1,     4,    -1,     4,
      -1,    -1,    24,    25,    -1,    -1,    -1,    -1,    -1,    24,
      25,    -1,    -1,    24,    25,    24,    25,    24,    25,    24,
      25,     4,    -1,    -1,     7,    -1,    -1,    -1,    -1,    -1,
      13,    -1,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    24
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   144,   253,     0,     1,     3,     5,    17,    18,    19,
      21,    22,    23,    30,    31,    32,    33,    34,    41,    48,
      51,    63,    67,    79,    80,    81,    82,    88,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   102,   103,
     104,   105,   106,   107,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   138,   139,   140,   141,   142,   146,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   208,   209,   210,   213,
     214,   219,   231,   232,   235,   236,   252,   254,     4,     6,
       7,     8,    10,   161,    68,    27,     4,    24,    45,   145,
       1,     9,    10,   148,   148,    68,     1,     7,   100,   101,
     145,    25,   145,    27,    68,    69,   145,   145,    25,   145,
      68,    68,     4,     4,     4,     4,    25,   145,    25,   145,
     148,   148,   148,   148,     4,     4,     4,     4,     4,   148,
       4,   148,   100,   101,   147,   147,   148,   148,     4,   148,
     148,   148,   148,   148,    68,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   148,    68,   148,   148,    68,   148,
     148,   148,   148,    68,    27,    27,    27,    27,    17,    19,
      20,   206,   207,   220,   211,   215,   233,   237,    16,    16,
      16,    15,    28,    28,   145,   221,   222,    28,    31,    49,
      50,    52,    53,    54,    55,    71,    83,    84,    89,   108,
     212,    28,    39,    40,    44,    56,    57,    58,    60,    61,
      62,    64,    65,    66,    83,    84,    89,   216,    28,    72,
      83,    84,    89,   234,     1,    28,    77,    78,   238,    68,
      25,    45,   145,    25,   145,   207,    27,    83,    84,   224,
      25,   145,    11,    25,   145,   145,    11,    25,   145,    11,
      12,    14,    25,   145,    25,   145,    25,   145,    25,   145,
     145,   145,    25,    86,   145,    21,    22,    38,   102,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     141,    25,   145,   217,    60,    61,    65,   218,    25,   145,
     145,    68,    25,   145,   229,   145,   145,    25,    86,   145,
     145,   145,    25,    86,   145,   239,   241,   243,   245,   145,
     145,    28,    31,    70,    71,    89,   225,    25,   145,    25,
     145,    25,   145,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   148,   148,   148,   148,    15,
      25,   145,   218,    25,   145,    25,   145,    15,    25,   145,
      68,    15,    45,   230,    25,   145,    25,   145,    29,   145,
      25,    36,    37,   248,   249,   251,    27,    27,    85,    25,
     145,   226,    25,   145,    25,    86,   145,    68,    75,    76,
      77,    11,    42,    43,   227,   228,   240,   242,   244,    11,
      35,   246,   250,   246,   223,     7,    13,    15,   145,    25,
     145,   230,   246,   246,   246,   249,   247,    11,    27,     7,
     145,   246,   250,   250,   224,    11,    28,   250
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
/* Line 1792 of yacc.c  */
#line 197 "sg.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); }
    break;

  case 4:
/* Line 1792 of yacc.c  */
#line 198 "sg.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); }
    break;

  case 5:
/* Line 1792 of yacc.c  */
#line 202 "sg.y"
    { httpsConnectionCacheSize = atoi( (yyvsp[(2) - (2)].string) ); ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 6:
/* Line 1792 of yacc.c  */
#line 206 "sg.y"
    { (yyval.integer) = UFDB_ALLOW; }
    break;

  case 7:
/* Line 1792 of yacc.c  */
#line 207 "sg.y"
    { (yyval.integer) = UFDB_DENY; }
    break;

  case 8:
/* Line 1792 of yacc.c  */
#line 211 "sg.y"
    { (yyval.integer) = 1; }
    break;

  case 9:
/* Line 1792 of yacc.c  */
#line 212 "sg.y"
    { (yyval.integer) = 0; }
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 213 "sg.y"
    { ufdbLogFatalError( "syntax error at line %d: expected 'on' or 'off'", lineno );   }
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 217 "sg.y"
    { UFDBglobalLogPass = (yyvsp[(2) - (2)].integer); }
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 221 "sg.y"
    { UFDBglobalLogBlock = (yyvsp[(2) - (2)].integer); }
    break;

  case 13:
/* Line 1792 of yacc.c  */
#line 225 "sg.y"
    { UFDBglobalLogAllRequests = (yyvsp[(2) - (2)].integer); }
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 229 "sg.y"
    { UFDBglobalDebugHttpd = (yyvsp[(2) - (2)].integer); }
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 233 "sg.y"
    { UFDBglobalYoutubeEdufilter = (yyvsp[(2) - (2)].integer); }
    break;

  case 16:
/* Line 1792 of yacc.c  */
#line 237 "sg.y"
    { UFDBglobalYoutubeEdufilterID = (yyvsp[(2) - (2)].string); }
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 241 "sg.y"
    { UFDBglobalAllowGoogleHTTPSusingIP = (yyvsp[(2) - (2)].integer); }
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 245 "sg.y"
    { UFDBglobalDebug = (yyvsp[(2) - (2)].integer); }
    break;

  case 19:
/* Line 1792 of yacc.c  */
#line 246 "sg.y"
    { UFDBglobalDebug = atoi( (yyvsp[(2) - (2)].string) ); }
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 251 "sg.y"
    { ufdbLogError( "line %d: option enforce-https-with-hostname must be part of the security category", lineno );  }
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 256 "sg.y"
    { ufdbLogError( "line %d: option enforce-https-official-certificate must be part of the security category", lineno );  }
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 261 "sg.y"
    { ufdbLogError( "line %d: option https-prohibit-insecure-sslv2 must be part of the security category", lineno );  }
    break;

  case 23:
/* Line 1792 of yacc.c  */
#line 266 "sg.y"
    { ufdbLogError( "line %d: option https-prohibit-insecure-sslv3 must be part of the security category", lineno );  }
    break;

  case 24:
/* Line 1792 of yacc.c  */
#line 271 "sg.y"
    { (yyval.integer) = UFDB_API_HTTPS_CHECK_OFF; }
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 272 "sg.y"
    { (yyval.integer) = UFDB_API_HTTPS_CHECK_QUEUE_CHECKS; }
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 273 "sg.y"
    { (yyval.integer) = UFDB_API_HTTPS_CHECK_AGGRESSIVE; }
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 274 "sg.y"
    { (yyval.integer) = UFDB_API_HTTPS_LOG_ONLY; }
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 278 "sg.y"
    { UFDBsetTunnelCheckMethod( (yyvsp[(2) - (2)].integer) ); }
    break;

  case 29:
/* Line 1792 of yacc.c  */
#line 282 "sg.y"
    { ufdbSetting("administrator",(yyvsp[(2) - (2)].string)); }
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 286 "sg.y"
    { ufdbSetting("dbhome",(yyvsp[(2) - (2)].string)); }
    break;

  case 31:
/* Line 1792 of yacc.c  */
#line 287 "sg.y"
    { ufdbSetting("dbhome",(yyvsp[(2) - (2)].string)); }
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 291 "sg.y"
    { setRefreshUserlist( atoi((yyvsp[(2) - (2)].string)) ); }
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 295 "sg.y"
    { setRefreshDomainlist( atoi((yyvsp[(2) - (2)].string)) ); }
    break;

  case 34:
/* Line 1792 of yacc.c  */
#line 300 "sg.y"
    { UFDBglobalURLlookupResultDBreload = (yyvsp[(2) - (2)].integer); }
    break;

  case 35:
/* Line 1792 of yacc.c  */
#line 304 "sg.y"
    { UFDBglobalURLlookupResultFatalError = (yyvsp[(2) - (2)].integer); }
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 308 "sg.y"
    { UFDBglobalURLlookupDelayDBreload = (yyvsp[(2) - (2)].integer); }
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 312 "sg.y"
    { ufdbFree( UFDBglobalSquidVersion );  UFDBglobalSquidVersion = (yyvsp[(2) - (2)].string);  }
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 317 "sg.y"
    { int new_n_workers;
					  /* ONLY increase #workers */
					  new_n_workers = atoi( (yyvsp[(2) - (2)].string) );  
					  if (new_n_workers < 32)
					  {
					     ufdbLogError( "num-worker-threads must be at least 32" );
					     new_n_workers = 32;
					  }
					  else if (new_n_workers > UFDB_MAX_THREADS)
					  {
					     ufdbLogError( "num-worker-threads can be at most %d", UFDB_MAX_THREADS );
					     new_n_workers = UFDB_MAX_THREADS;
					  }
					  if (new_n_workers > UFDBglobalNworkers)
					     UFDBglobalNworkers = new_n_workers;
					}
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 337 "sg.y"
    { UFDBglobalUploadCrashReports = (yyvsp[(2) - (2)].integer);  }
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 342 "sg.y"
    { UFDBglobalLookupReverseIP = (yyvsp[(2) - (2)].integer);  }
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 347 "sg.y"
    { UFDBglobalUseAlsoIPv6onWan = (yyvsp[(2) - (2)].integer);  }
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 352 "sg.y"
    { UFDBglobalSquidUsesSSLbump = (yyvsp[(2) - (2)].integer);  }
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 356 "sg.y"
    { UFDBglobalShowURLdetails = (yyvsp[(2) - (2)].integer); }
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 360 "sg.y"
    { UFDBglobalDebugSkype = (yyvsp[(2) - (2)].integer); }
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 364 "sg.y"
    { UFDBglobalDebugGtalk = (yyvsp[(2) - (2)].integer); }
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 368 "sg.y"
    { UFDBglobalDebugYahooMsg = (yyvsp[(2) - (2)].integer); }
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 372 "sg.y"
    { UFDBglobalDebugAim = (yyvsp[(2) - (2)].integer); }
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 376 "sg.y"
    { UFDBglobalDebugFBchat = (yyvsp[(2) - (2)].integer); }
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 380 "sg.y"
    { UFDBglobalDebugCitrixOnline = (yyvsp[(2) - (2)].integer); }
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 384 "sg.y"
    { UFDBglobalExpressionOptimisation = (yyvsp[(2) - (2)].integer); }
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 388 "sg.y"
    { UFDBglobalDebugRegexp = (yyvsp[(2) - (2)].integer); }
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 392 "sg.y"
    { UFDBglobalDebugExternalScripts = (yyvsp[(2) - (2)].integer); }
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 396 "sg.y"
    { ufdbFree( UFDBglobalEmailServer ); UFDBglobalEmailServer = (yyvsp[(2) - (2)].string); }
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 400 "sg.y"
    { ufdbFree( UFDBglobalMyHostname ); UFDBglobalMyHostname = (yyvsp[(2) - (2)].string); }
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 404 "sg.y"
    { ufdbFree( UFDBglobalAdminEmail ); UFDBglobalAdminEmail = (yyvsp[(2) - (2)].string); }
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 408 "sg.y"
    { ufdbFree( UFDBglobalSenderEmail ); UFDBglobalSenderEmail = (yyvsp[(2) - (2)].string); }
    break;

  case 57:
/* Line 1792 of yacc.c  */
#line 412 "sg.y"
    {  ufdbFree( UFDBglobalExternalStatusCommand );  UFDBglobalExternalStatusCommand = (yyvsp[(2) - (2)].string); }
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 416 "sg.y"
    { ufdbSetting("logdir",(yyvsp[(2) - (2)].string)); }
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 417 "sg.y"
    { ufdbSetting("logdir",(yyvsp[(2) - (2)].string)); }
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 421 "sg.y"
    { ufdbSetting("pidfile",(yyvsp[(2) - (2)].string)); }
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 422 "sg.y"
    { ufdbSetting("pidfile",(yyvsp[(2) - (2)].string)); }
    break;

  case 62:
/* Line 1792 of yacc.c  */
#line 426 "sg.y"
    { ufdbSetting( "port", (yyvsp[(2) - (2)].string) ); }
    break;

  case 63:
/* Line 1792 of yacc.c  */
#line 430 "sg.y"
    { 
#if HAVE_UNIX_SOCKETS
                                             ufdbLogError( "ufdbguardd is configured to use UNIX sockets.  \"interface\" is ignored." );
#else
		                             if (strcmp((yyvsp[(2) - (2)].string),"all")== 0)
						strcpy( UFDBglobalInterface, "all" );    
					     else
					        ufdbLogFatalError( "interface must be \"all\" or IP address" );
#endif
					     ufdbFree( (yyvsp[(2) - (2)].string) );
					   }
    break;

  case 64:
/* Line 1792 of yacc.c  */
#line 441 "sg.y"
    { strcpy( UFDBglobalInterface, (yyvsp[(2) - (2)].string) );  ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 65:
/* Line 1792 of yacc.c  */
#line 445 "sg.y"
    { ufdbSetCPU( (yyvsp[(2) - (2)].string) ); ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 66:
/* Line 1792 of yacc.c  */
#line 446 "sg.y"
    { ufdbSetCPU( (yyvsp[(2) - (2)].string) ); ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 451 "sg.y"
    { UFDBglobalUploadStats = (yyvsp[(2) - (2)].integer);   }
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 456 "sg.y"
    { strcpy( UFDBglobalRedirectHttps, (yyvsp[(2) - (2)].string) );  ufdbFree( (yyvsp[(2) - (2)].string) );  }
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 461 "sg.y"
    { strcpy( UFDBglobalRedirectBumpedHttps, (yyvsp[(2) - (2)].string) );  ufdbFree( (yyvsp[(2) - (2)].string) );  }
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 466 "sg.y"
    { strcpy( UFDBglobalLoadingDatabaseRedirect, (yyvsp[(2) - (2)].string) );  ufdbFree( (yyvsp[(2) - (2)].string) );  }
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 471 "sg.y"
    { strcpy( UFDBglobalFatalErrorRedirect, (yyvsp[(2) - (2)].string) );  ufdbFree( (yyvsp[(2) - (2)].string) );  }
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 476 "sg.y"
    {
			UFDBglobalLogUncategorisedURLs = (yyvsp[(2) - (2)].integer);   
		     }
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 483 "sg.y"
    { 
			UFDBglobalAnalyseUncategorisedURLs = (yyvsp[(2) - (2)].integer);   
		     }
    break;

  case 74:
/* Line 1792 of yacc.c  */
#line 488 "sg.y"
    {
			UFDBglobalAnalyseUncategorisedURLs = atoi( (yyvsp[(2) - (2)].string) ); 
			ufdbFree( (yyvsp[(2) - (2)].string) ); 
		     }
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 496 "sg.y"
    {
		        UFDBglobalStripDomainFromUsername = (yyvsp[(2) - (2)].integer);
		     }
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 503 "sg.y"
    { UFDBglobalSafeSearch = (yyvsp[(2) - (2)].integer); }
    break;

  case 77:
/* Line 1792 of yacc.c  */
#line 508 "sg.y"
    { 
		       UFDBglobalMaxLogfileSize = strtoul( (yyvsp[(2) - (2)].string), NULL, 10 );
		       ufdbFree( (yyvsp[(2) - (2)].string) );
		       if (UFDBglobalMaxLogfileSize < 2 * 1024 * 1024)		/* minimum is 2 MB */
		          UFDBglobalMaxLogfileSize = 2 * 1024 * 1024;
		       if (UFDBglobalMaxLogfileSize > 2000000000)		/* maximum is 2 GB */
		          UFDBglobalMaxLogfileSize = 2000000000;
		     }
    break;

  case 78:
/* Line 1792 of yacc.c  */
#line 519 "sg.y"
    { UFDBglobalHttpdPort = atoi( (yyvsp[(3) - (3)].string) ); ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 79:
/* Line 1792 of yacc.c  */
#line 520 "sg.y"
    { if (strcmp((yyvsp[(3) - (3)].string),"all")== 0)
						strcpy( UFDBglobalHttpdInterface, "all" );    
					     else
					        ufdbLogFatalError( "http-server interface must be \"all\" or IP address" );
					     ufdbFree( (yyvsp[(3) - (3)].string) );
					   }
    break;

  case 80:
/* Line 1792 of yacc.c  */
#line 526 "sg.y"
    { if (strcmp((yyvsp[(3) - (3)].string),"all")== 0)
						strcpy( UFDBglobalHttpdInterface, "all" );    
					     else
					        ufdbLogFatalError( "http-server interface must be \"all\" or IP address" );
					     ufdbFree( (yyvsp[(3) - (3)].string) );
					   }
    break;

  case 81:
/* Line 1792 of yacc.c  */
#line 532 "sg.y"
    { strcpy( UFDBglobalHttpdInterface, (yyvsp[(3) - (3)].string) );       ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 533 "sg.y"
    { strcpy( UFDBglobalHttpdImagesDirectory, (yyvsp[(3) - (3)].string) ); ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 534 "sg.y"
    { strcpy( UFDBglobalHttpdImagesDirectory, (yyvsp[(3) - (3)].string) ); ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 87:
/* Line 1792 of yacc.c  */
#line 547 "sg.y"
    { ufdbCategory( (yyvsp[(2) - (2)].string) ); }
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 548 "sg.y"
    { ufdbCategory( ufdbStrdup("aggressive") );
		                         yyerror( (char *) "\"aggressive\" is a keyword and must be surrounded by quotes" ); }
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 550 "sg.y"
    { ufdbCategory( ufdbStrdup("allow") );
		                         yyerror( (char *) "\"allow\" is a keyword and must be surrounded by quotes" ); }
    break;

  case 90:
/* Line 1792 of yacc.c  */
#line 552 "sg.y"
    { ufdbCategory( ufdbStrdup("deny") );
		                         yyerror( (char *) "\"deny\" is a keyword and must be surrounded by quotes" ); }
    break;

  case 91:
/* Line 1792 of yacc.c  */
#line 554 "sg.y"
    { ufdbCategory( ufdbStrdup("syntax-error") );
		                         yyerror( (char *) "erroneous category definition.  Perhaps the category ID is a reserved word?" ); }
    break;

  case 92:
/* Line 1792 of yacc.c  */
#line 560 "sg.y"
    { ufdbCategoryEnd(); }
    break;

  case 95:
/* Line 1792 of yacc.c  */
#line 568 "sg.y"
    { ufdbCategoryDomainList( (yyvsp[(2) - (2)].string) ); }
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 569 "sg.y"
    { ufdbCategoryDomainList( (yyvsp[(2) - (2)].string) ); }
    break;

  case 97:
/* Line 1792 of yacc.c  */
#line 570 "sg.y"
    { ufdbCategoryDomainList( NULL ); }
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 571 "sg.y"
    { ufdbCategoryExecDomainList( (yyvsp[(2) - (2)].string) ); }
    break;

  case 99:
/* Line 1792 of yacc.c  */
#line 572 "sg.y"
    { ufdbCategoryUrlList( (yyvsp[(2) - (2)].string) ); }
    break;

  case 100:
/* Line 1792 of yacc.c  */
#line 573 "sg.y"
    { ufdbCategoryUrlList( (yyvsp[(2) - (2)].string) ); }
    break;

  case 101:
/* Line 1792 of yacc.c  */
#line 574 "sg.y"
    { ufdbCategoryUrlList( NULL ); }
    break;

  case 102:
/* Line 1792 of yacc.c  */
#line 575 "sg.y"
    { ufdbCategoryExpressionList( (yyvsp[(2) - (2)].string), "n" ); }
    break;

  case 103:
/* Line 1792 of yacc.c  */
#line 576 "sg.y"
    { ufdbCategoryExpressionList( (yyvsp[(2) - (2)].string), "n" ); }
    break;

  case 104:
/* Line 1792 of yacc.c  */
#line 577 "sg.y"
    { ufdbCategoryExpressionList( NULL, NULL ); }
    break;

  case 105:
/* Line 1792 of yacc.c  */
#line 578 "sg.y"
    { ufdbCategoryExpressionList( (yyvsp[(3) - (3)].string), "i" ); }
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 579 "sg.y"
    { ufdbCategoryExpressionList( (yyvsp[(3) - (3)].string), "i" ); }
    break;

  case 107:
/* Line 1792 of yacc.c  */
#line 580 "sg.y"
    { ufdbCategoryExpressionList( (yyvsp[(3) - (3)].string), "i" ); }
    break;

  case 108:
/* Line 1792 of yacc.c  */
#line 581 "sg.y"
    { ufdbCategoryExpressionList( (yyvsp[(3) - (3)].string), "i" ); }
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 582 "sg.y"
    { ufdbCategoryCACertsFile( (yyvsp[(2) - (2)].string) ); }
    break;

  case 110:
/* Line 1792 of yacc.c  */
#line 583 "sg.y"
    { ufdbCategoryCACertsFile( (yyvsp[(2) - (2)].string) ); }
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 584 "sg.y"
    { ufdbCategoryCACertsDir( (yyvsp[(2) - (2)].string) ); }
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 585 "sg.y"
    { ufdbCategoryCACertsDir( (yyvsp[(2) - (2)].string) ); }
    break;

  case 113:
/* Line 1792 of yacc.c  */
#line 586 "sg.y"
    { ufdbCategoryRedirect( (yyvsp[(2) - (2)].string) ); }
    break;

  case 114:
/* Line 1792 of yacc.c  */
#line 587 "sg.y"
    { ufdbCategoryRedirect( (yyvsp[(2) - (2)].string) ); }
    break;

  case 115:
/* Line 1792 of yacc.c  */
#line 588 "sg.y"
    { ufdbCategoryRewrite( (yyvsp[(2) - (2)].string) ); }
    break;

  case 116:
/* Line 1792 of yacc.c  */
#line 589 "sg.y"
    { ufdbCategoryRewrite( (yyvsp[(2) - (2)].string) ); }
    break;

  case 117:
/* Line 1792 of yacc.c  */
#line 590 "sg.y"
    { ufdbCategoryTime( (yyvsp[(2) - (2)].string), UFDB_ACL_WITHIN ); }
    break;

  case 118:
/* Line 1792 of yacc.c  */
#line 591 "sg.y"
    { ufdbCategoryTime( (yyvsp[(2) - (2)].string), UFDB_ACL_OUTSIDE ); }
    break;

  case 119:
/* Line 1792 of yacc.c  */
#line 592 "sg.y"
    { ufdbCategoryBlockConnect( (yyvsp[(3) - (3)].integer) ); }
    break;

  case 120:
/* Line 1792 of yacc.c  */
#line 593 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_SAFE_SEARCH );  }
    break;

  case 121:
/* Line 1792 of yacc.c  */
#line 594 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_YOUTUBE_EDUFILTER );  }
    break;

  case 122:
/* Line 1792 of yacc.c  */
#line 595 "sg.y"
    { ufdbCategoryOption(  1, UFDB_OPT_HTTPS_WITH_HOSTNAME );  }
    break;

  case 123:
/* Line 1792 of yacc.c  */
#line 596 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_HTTPS_WITH_HOSTNAME );  }
    break;

  case 124:
/* Line 1792 of yacc.c  */
#line 597 "sg.y"
    { ufdbCategoryOption(  1, UFDB_OPT_HTTPS_OFFICAL_CERTIFICATE );  }
    break;

  case 125:
/* Line 1792 of yacc.c  */
#line 598 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_HTTPS_OFFICAL_CERTIFICATE );  }
    break;

  case 126:
/* Line 1792 of yacc.c  */
#line 599 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_PROHIBIT_INSECURE_SSLV2 );  }
    break;

  case 127:
/* Line 1792 of yacc.c  */
#line 600 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_PROHIBIT_INSECURE_SSLV3 );  }
    break;

  case 128:
/* Line 1792 of yacc.c  */
#line 601 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_SKYPE_OVER_HTTPS );  }
    break;

  case 129:
/* Line 1792 of yacc.c  */
#line 602 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_GTALK_OVER_HTTPS );  }
    break;

  case 130:
/* Line 1792 of yacc.c  */
#line 603 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_YAHOOMSG_OVER_HTTPS );  }
    break;

  case 131:
/* Line 1792 of yacc.c  */
#line 604 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_AIM_OVER_HTTPS );  }
    break;

  case 132:
/* Line 1792 of yacc.c  */
#line 605 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_FBCHAT_OVER_HTTPS );  }
    break;

  case 133:
/* Line 1792 of yacc.c  */
#line 606 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_CITRIXONLINE_OVER_HTTPS );  }
    break;

  case 134:
/* Line 1792 of yacc.c  */
#line 607 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_ANYDESK_OVER_HTTPS );  }
    break;

  case 135:
/* Line 1792 of yacc.c  */
#line 608 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_TEAMVIEWER_OVER_HTTPS );  }
    break;

  case 136:
/* Line 1792 of yacc.c  */
#line 609 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_UNKNOWN_PROTOCOL_OVER_HTTPS );  }
    break;

  case 137:
/* Line 1792 of yacc.c  */
#line 610 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(3) - (3)].string) ); 
		                                  ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 138:
/* Line 1792 of yacc.c  */
#line 612 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(3) - (3)].string) ); 
		                                  ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 139:
/* Line 1792 of yacc.c  */
#line 614 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(2) - (2)].string) ); 
		                                  ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 140:
/* Line 1792 of yacc.c  */
#line 616 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(2) - (2)].string) ); 
		                                  ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 141:
/* Line 1792 of yacc.c  */
#line 621 "sg.y"
    { defSource( (yyvsp[(2) - (2)].string) ); }
    break;

  case 142:
/* Line 1792 of yacc.c  */
#line 625 "sg.y"
    { defSourceEnd(); }
    break;

  case 148:
/* Line 1792 of yacc.c  */
#line 637 "sg.y"
    { ufdbSourceUserList( (yyvsp[(2) - (2)].string) ); }
    break;

  case 149:
/* Line 1792 of yacc.c  */
#line 638 "sg.y"
    { ufdbSourceUserList( (yyvsp[(2) - (2)].string) ); }
    break;

  case 150:
/* Line 1792 of yacc.c  */
#line 639 "sg.y"
    { ufdbSourceUserList( (yyvsp[(3) - (3)].string) ); }
    break;

  case 151:
/* Line 1792 of yacc.c  */
#line 640 "sg.y"
    { ufdbSourceUserList( (yyvsp[(3) - (3)].string) ); }
    break;

  case 152:
/* Line 1792 of yacc.c  */
#line 641 "sg.y"
    { ufdbSourceExecUserList( (yyvsp[(2) - (2)].string) ); }
    break;

  case 153:
/* Line 1792 of yacc.c  */
#line 642 "sg.y"
    { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[(2) - (2)].string) ); }
    break;

  case 154:
/* Line 1792 of yacc.c  */
#line 643 "sg.y"
    { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[(2) - (2)].string) ); }
    break;

  case 155:
/* Line 1792 of yacc.c  */
#line 644 "sg.y"
    { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[(3) - (3)].string) ); }
    break;

  case 156:
/* Line 1792 of yacc.c  */
#line 645 "sg.y"
    { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[(3) - (3)].string) ); }
    break;

  case 157:
/* Line 1792 of yacc.c  */
#line 646 "sg.y"
    { ufdbSourceUserQuota( (yyvsp[(2) - (4)].string), (yyvsp[(3) - (4)].string), "3600" );  
		                                   ufdbFree( (yyvsp[(2) - (4)].string) ); ufdbFree( (yyvsp[(3) - (4)].string) ); }
    break;

  case 158:
/* Line 1792 of yacc.c  */
#line 648 "sg.y"
    { ufdbSourceUserQuota( (yyvsp[(2) - (4)].string), (yyvsp[(3) - (4)].string), "86400" );  
		                                   ufdbFree( (yyvsp[(2) - (4)].string) ); ufdbFree( (yyvsp[(3) - (4)].string) ); }
    break;

  case 159:
/* Line 1792 of yacc.c  */
#line 650 "sg.y"
    { ufdbSourceUserQuota( (yyvsp[(2) - (4)].string), (yyvsp[(3) - (4)].string), "604800" );  
		                                   ufdbFree( (yyvsp[(2) - (4)].string) ); ufdbFree( (yyvsp[(3) - (4)].string) ); }
    break;

  case 160:
/* Line 1792 of yacc.c  */
#line 652 "sg.y"
    { ufdbSourceUserQuota( (yyvsp[(2) - (4)].string), (yyvsp[(3) - (4)].string), (yyvsp[(4) - (4)].string) );  
		                                   ufdbFree( (yyvsp[(2) - (4)].string) ); ufdbFree( (yyvsp[(3) - (4)].string) ); ufdbFree( (yyvsp[(4) - (4)].string) ); }
    break;

  case 162:
/* Line 1792 of yacc.c  */
#line 655 "sg.y"
    { defSourceIpList( (yyvsp[(2) - (2)].string) ); }
    break;

  case 163:
/* Line 1792 of yacc.c  */
#line 656 "sg.y"
    { defSourceIpList( (yyvsp[(2) - (2)].string) ); }
    break;

  case 164:
/* Line 1792 of yacc.c  */
#line 657 "sg.y"
    { ufdbSourceEval( UFDB_EVAL_AND ); }
    break;

  case 165:
/* Line 1792 of yacc.c  */
#line 658 "sg.y"
    { ufdbSourceEval( UFDB_EVAL_OR ); }
    break;

  case 166:
/* Line 1792 of yacc.c  */
#line 659 "sg.y"
    { defSourceTime( (yyvsp[(2) - (2)].string), UFDB_ACL_WITHIN ); }
    break;

  case 167:
/* Line 1792 of yacc.c  */
#line 660 "sg.y"
    { defSourceTime( (yyvsp[(2) - (2)].string), UFDB_ACL_OUTSIDE ); }
    break;

  case 168:
/* Line 1792 of yacc.c  */
#line 661 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(3) - (3)].string) ); 
						   ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 169:
/* Line 1792 of yacc.c  */
#line 663 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(3) - (3)].string) ); 
						   ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 170:
/* Line 1792 of yacc.c  */
#line 665 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(2) - (2)].string) ); 
						   ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 171:
/* Line 1792 of yacc.c  */
#line 667 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(2) - (2)].string) ); 
						   ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 172:
/* Line 1792 of yacc.c  */
#line 669 "sg.y"
    { lastSource->cont_search = 1; }
    break;

  case 174:
/* Line 1792 of yacc.c  */
#line 675 "sg.y"
    { defSourceDomain( (yyvsp[(2) - (2)].string) ); }
    break;

  case 175:
/* Line 1792 of yacc.c  */
#line 676 "sg.y"
    { defSourceDomain( (yyvsp[(2) - (2)].string) ); }
    break;

  case 178:
/* Line 1792 of yacc.c  */
#line 682 "sg.y"
    { ufdbSourceUser( (yyvsp[(2) - (2)].string) ); }
    break;

  case 179:
/* Line 1792 of yacc.c  */
#line 683 "sg.y"
    { ufdbSourceUser( (yyvsp[(2) - (2)].string) ); }
    break;

  case 184:
/* Line 1792 of yacc.c  */
#line 696 "sg.y"
    { sgAcl( (yyvsp[(1) - (2)].string), NULL, UFDB_ACL_NONE );  }
    break;

  case 185:
/* Line 1792 of yacc.c  */
#line 697 "sg.y"
    { sgAcl( (yyvsp[(1) - (4)].string), (yyvsp[(3) - (4)].string), UFDB_ACL_WITHIN );  }
    break;

  case 186:
/* Line 1792 of yacc.c  */
#line 698 "sg.y"
    { sgAcl( (yyvsp[(1) - (4)].string), (yyvsp[(3) - (4)].string), UFDB_ACL_OUTSIDE ); }
    break;

  case 188:
/* Line 1792 of yacc.c  */
#line 704 "sg.y"
    { sgAcl( NULL, NULL, UFDB_ACL_ELSE );    }
    break;

  case 192:
/* Line 1792 of yacc.c  */
#line 714 "sg.y"
    { }
    break;

  case 193:
/* Line 1792 of yacc.c  */
#line 715 "sg.y"
    { sgAclSetValue( "rewrite", (yyvsp[(2) - (2)].string), 0 ); }
    break;

  case 194:
/* Line 1792 of yacc.c  */
#line 716 "sg.y"
    { sgAclSetValue( "rewrite", (yyvsp[(2) - (2)].string), 0 ); }
    break;

  case 195:
/* Line 1792 of yacc.c  */
#line 717 "sg.y"
    { sgAclSetValue( "redirect", (yyvsp[(2) - (2)].string), 0 ); }
    break;

  case 196:
/* Line 1792 of yacc.c  */
#line 718 "sg.y"
    { sgAclSetValue( "redirect", (yyvsp[(2) - (2)].string), 0 ); }
    break;

  case 197:
/* Line 1792 of yacc.c  */
#line 719 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(3) - (3)].string) ); 
						  ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 198:
/* Line 1792 of yacc.c  */
#line 721 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(3) - (3)].string) ); 
						  ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 199:
/* Line 1792 of yacc.c  */
#line 723 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(2) - (2)].string) ); 
						  ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 200:
/* Line 1792 of yacc.c  */
#line 725 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(2) - (2)].string) ); 
						  ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 202:
/* Line 1792 of yacc.c  */
#line 731 "sg.y"
    { yyerror( (char *) "\"aggressive\" is a keyword and must be surrounded by quotes" ); }
    break;

  case 203:
/* Line 1792 of yacc.c  */
#line 732 "sg.y"
    { sgAclSetValue( "pass", (yyvsp[(2) - (2)].string), 1 ); }
    break;

  case 204:
/* Line 1792 of yacc.c  */
#line 733 "sg.y"
    { yyerror( (char *) "\"aggressive\" is a keyword and must be surrounded by quotes" ); }
    break;

  case 205:
/* Line 1792 of yacc.c  */
#line 734 "sg.y"
    { sgAclSetValue( "pass", (yyvsp[(3) - (3)].string), 0 ); }
    break;

  case 207:
/* Line 1792 of yacc.c  */
#line 739 "sg.y"
    { sgIp( (yyvsp[(1) - (1)].string) ); ufdbFree( (yyvsp[(1) - (1)].string) ); }
    break;

  case 208:
/* Line 1792 of yacc.c  */
#line 743 "sg.y"
    { sgIp( (yyvsp[(1) - (1)].string) ); ufdbFree( (yyvsp[(1) - (1)].string) ); }
    break;

  case 210:
/* Line 1792 of yacc.c  */
#line 748 "sg.y"
    { sgIp( "255.255.255.255" );  sgSetIpType( SG_IPTYPE_HOST, NULL, 0 ); }
    break;

  case 211:
/* Line 1792 of yacc.c  */
#line 749 "sg.y"
    { sgSetIpType( SG_IPTYPE_CIDR, NULL, 0 ); }
    break;

  case 212:
/* Line 1792 of yacc.c  */
#line 750 "sg.y"
    { sgSetIpType( SG_IPTYPE_CLASS, NULL, 0 ); }
    break;

  case 213:
/* Line 1792 of yacc.c  */
#line 751 "sg.y"
    { sgSetIpType( SG_IPTYPE_RANGE, NULL, 0 ); }
    break;

  case 215:
/* Line 1792 of yacc.c  */
#line 756 "sg.y"
    { sgIp( (yyvsp[(1) - (1)].string) );  ufdbFree( (yyvsp[(1) - (1)].string) );  }
    break;

  case 216:
/* Line 1792 of yacc.c  */
#line 760 "sg.y"
    { sgRewrite( (yyvsp[(2) - (2)].string) ); }
    break;

  case 217:
/* Line 1792 of yacc.c  */
#line 761 "sg.y"
    { sgRewrite( (yyvsp[(2) - (2)].string) ); }
    break;

  case 221:
/* Line 1792 of yacc.c  */
#line 775 "sg.y"
    { sgRewriteSubstitute( (yyvsp[(1) - (1)].string) ); ufdbFree( (yyvsp[(1) - (1)].string) ); }
    break;

  case 222:
/* Line 1792 of yacc.c  */
#line 776 "sg.y"
    { sgRewriteTime( (yyvsp[(2) - (2)].string), UFDB_ACL_WITHIN ); }
    break;

  case 223:
/* Line 1792 of yacc.c  */
#line 777 "sg.y"
    { sgRewriteTime( (yyvsp[(2) - (2)].string), UFDB_ACL_OUTSIDE ); }
    break;

  case 224:
/* Line 1792 of yacc.c  */
#line 778 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(3) - (3)].string) ); 							      ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 225:
/* Line 1792 of yacc.c  */
#line 779 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(3) - (3)].string) ); 							      ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 226:
/* Line 1792 of yacc.c  */
#line 780 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(2) - (2)].string) ); 							      ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 227:
/* Line 1792 of yacc.c  */
#line 781 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(2) - (2)].string) ); 							      ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 228:
/* Line 1792 of yacc.c  */
#line 786 "sg.y"
    { sgTime( (yyvsp[(2) - (2)].string) ); }
    break;

  case 232:
/* Line 1792 of yacc.c  */
#line 800 "sg.y"
    { sgTimeElementInit(); }
    break;

  case 233:
/* Line 1792 of yacc.c  */
#line 800 "sg.y"
    { sgTimeElementAdd((yyvsp[(3) - (3)].string),T_WEEKDAY); }
    break;

  case 235:
/* Line 1792 of yacc.c  */
#line 801 "sg.y"
    { sgTimeElementInit(); }
    break;

  case 236:
/* Line 1792 of yacc.c  */
#line 801 "sg.y"
    { sgTimeElementAdd((yyvsp[(3) - (3)].string),T_WEEKLY); }
    break;

  case 238:
/* Line 1792 of yacc.c  */
#line 802 "sg.y"
    { sgTimeElementInit(); }
    break;

  case 239:
/* Line 1792 of yacc.c  */
#line 802 "sg.y"
    { sgTimeElementAdd((yyvsp[(3) - (3)].string),T_WEEKLY); }
    break;

  case 241:
/* Line 1792 of yacc.c  */
#line 803 "sg.y"
    { sgTimeElementInit(); }
    break;

  case 242:
/* Line 1792 of yacc.c  */
#line 803 "sg.y"
    { sgTimeElementEnd(); }
    break;

  case 243:
/* Line 1792 of yacc.c  */
#line 804 "sg.y"
    { ufdbLogFatalError( "invalid time specification at line %d", lineno );   }
    break;

  case 244:
/* Line 1792 of yacc.c  */
#line 808 "sg.y"
    { sgTimeElementClone(); }
    break;

  case 253:
/* Line 1792 of yacc.c  */
#line 821 "sg.y"
    { sgTimeElementAdd( (yyvsp[(1) - (1)].string), T_DVAL ); }
    break;

  case 254:
/* Line 1792 of yacc.c  */
#line 824 "sg.y"
    { sgTimeElementAdd( (yyvsp[(1) - (1)].tval), T_TVAL ); }
    break;

  case 255:
/* Line 1792 of yacc.c  */
#line 827 "sg.y"
    { sgTimeElementAdd( (yyvsp[(1) - (1)].string), T_DVALCRON ); }
    break;

  case 256:
/* Line 1792 of yacc.c  */
#line 831 "sg.y"
    {  yyerror( (char *) "syntax error" );  }
    break;


/* Line 1792 of yacc.c  */
#line 3643 "y.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 907 "sg.y"


int sgReadConfig( 
   char *            file )
{
   char *            defaultFile = (char *) DEFAULT_CONFIGFILE;
   struct Source *   source;
   struct Category * cat;
   struct Acl *      acl;

   lineno = 1;
   ufdbResetCPUs();

   UFDBglobalConfigFile = file;
   if (UFDBglobalConfigFile == NULL)
      UFDBglobalConfigFile = defaultFile;

   yyin = fopen( UFDBglobalConfigFile, "r" );
   if (yyin == NULL) 
   {
      syslog( LOG_ALERT, "%s: cannot open configuration file %s", UFDBprogname, UFDBglobalConfigFile );
      ufdbLogFatalError( "cannot open configuration file %s", UFDBglobalConfigFile );
      return 0;
   }

   ufdbLogMessage( "configuration file: %s", UFDBglobalConfigFile );

#if 0
   /* keep the old HTTPS redirection URL.  It is most likely that we need it during the database reload */
   strcpy( UFDBglobalRedirectHttps, UFDB_DEFAULT_HTTPS_REDIRECTION_URL );
#endif

   /* UFDBglobalDebug = 0; */
   strcpy( UFDBglobalInterface, "all" );
   /* UFDBglobalPortNum = UFDB_DAEMON_PORT;  the port can be set with a command line switch so do not reset it */
   /* UFDBglobalNworkers = 68;  do not reset this variable. */
   UFDBglobalDebugHttpd = 0;
   UFDBglobalLogPass = 0;
   UFDBglobalLogBlock = 0;
   UFDBglobalLogAllRequests = 0;
   UFDBglobalYoutubeEdufilter = 0;
   UFDBglobalYoutubeEdufilterID = (char *) "none";
   UFDBglobalAllowGoogleHTTPSusingIP = 0;

#if 0
   /* When a database is reloaded, these variables may NOT be reset since they are used during the reload !! */
   UFDBglobalURLlookupDelayDBreload = 0;
   UFDBglobalURLlookupResultDBreload = UFDB_ALLOW;
   UFDBglobalURLlookupResultFatalError = UFDB_ALLOW;
   strcpy( UFDBglobalLoadingDatabaseRedirect, "a-blocking-url" );
   ufdbFree( UFDBglobalSquidVersion );
#endif
   if (UFDBglobalSquidVersion == NULL)
      UFDBglobalSquidVersion = ufdbStrdup( UFDB_DEFAULT_SQUID_VERSION );

   UFDBglobalShowURLdetails = 0;
   UFDBglobalUploadCrashReports = 1;
   UFDBglobalLookupReverseIP = 0;
   UFDBglobalUseAlsoIPv6onWan = 1;
   UFDBglobalDebugSkype = 0;
   UFDBglobalDebugGtalk = 0;
   UFDBglobalDebugYahooMsg = 0;
   UFDBglobalDebugAim = 0;
   UFDBglobalDebugFBchat = 0;
   UFDBglobalDebugCitrixOnline = 0;
   UFDBglobalDebugRegexp = 0;
   UFDBglobalDebugExternalScripts = 0;
   UFDBglobalExpressionOptimisation = 1;
   UFDBglobalRefreshUserlistInterval = UFDB_DEFAULT_REFRESH_USERLIST;
   UFDBglobalRefreshDomainlistInterval = UFDB_DEFAULT_REFRESH_DOMAINLIST;
   UFDBglobalAnalyseUncategorisedURLs = 1;
   UFDBglobalLogUncategorisedURLs = 0;
   UFDBglobalUploadStats = 1;
   UFDBglobalSafeSearch = 1;
   UFDBglobalSkipSafeCategory = 0;
   UFDBglobalStripDomainFromUsername = 0;
   UFDBglobalTunnelCheckMethod = UFDB_API_HTTPS_CHECK_OFF;
   /* do not reset: UFDBglobalSquidUsesSSLbump = 0; */
   UFDBglobalHttpsWithHostname = 0;
   UFDBglobalHttpsOfficialCertificate = 0;
   UFDBglobalUnknownProtocolOverHttps = 1;
   UFDBglobalHttpsNoSSLv2 = 1;
   UFDBglobalHttpsNoSSLv3 = 0;
   UFDBglobalHttpdPort = 0;
   UFDBglobalDateOfCheckedDB[0] = '\0';
   strcpy( UFDBglobalHttpdInterface, "all" );
   strcpy( UFDBglobalHttpdImagesDirectory, "." );
 
   UFDBglobalDatabaseStatus = UFDB_API_STATUS_DATABASE_OK;

   (void) yyparse();		/* parse the configuration file */
   fclose( yyin );

   UFDBglobalDatabaseLoadTime = time( NULL );

   /*
    * For analysis of uncategorised URLs we also load a "checked" category
    * that contains URLs that are reviewed and checked not to be part of
    * any other category.
    */
   {
      char * dbhome;
      char   dbfname[1024];

      dbhome = ufdbSettingGetValue( (char *) "dbhome" );
      if (dbhome == NULL)
         dbhome = (char *) DEFAULT_DBHOME;

      /* TODO: check if "checked" was not already loaded... */
      if (UFDBglobalAnalyseUncategorisedURLs > 0)
      {
	 sprintf( dbfname, "%s/checked/domains.ufdb", dbhome );
	 if (UFDBloadDatabase( &UFDBglobalCheckedDB, dbfname ) != UFDB_API_OK)
	 {
	    UFDBglobalCheckedDB.mem = NULL;
	    UFDBglobalCheckedDB.index = NULL;
	    UFDBglobalCheckedDB.table.nNextLevels = 0;
	    if (UFDBglobalDebug)
	       ufdbLogMessage( "The URL database appears not be from URLfilterDB. No problem." );
	 }
	 else
	 {
	    sprintf( dbfname, "%s/checked/expressions", dbhome );
	    (void) UFDBloadExpressions( &UFDBglobalCheckedExpressions, dbfname );
	    ufdbLogMessage( "The implicitly allowed URL category 'checked' is loaded." );
	 }
      }
   }

   if (defaultAcl == NULL)
      ufdbLogFatalError( "\"default\" ACL is not defined" );
   else if (defaultAcl->pass == NULL)
      ufdbLogError( "\"default\" ACL is empty: by default all URLs are blocked." );

   /* A configuration file may have a source definition which is not used in the ACL list.
    * This raises the question "what to do with this ?".
    * If we do nothing, the source is matched but has no ACL definition and is silently skipped.
    * Most likely the administrator overlooked something so a warning is useful.
    */
   source = UFDBgetSourceList();  
   if (source == NULL  &&  defaultAcl == NULL)
      ufdbLogFatalError( "There are no sources and there is no default ACL" );

   for ( ; source != NULL;  source = source->next)
   {
      int found;

      found = 0;
      for (acl = AclList;  acl != NULL;  acl = acl->next)
      {
         if (strcmp( acl->name, source->name ) == 0)
	 {
	    found = 1;
	    break;
	 }
      }
      if (!found)
      {
         ufdbLogError( "source \"%s\" has no ACL.  *****\n"
	               "This most likely may lead to unexpected results when the source is matched.  *****\n"
		       "It is strongly suggested to remove the source definition OR add the source to the acl.  *****",
		       source->name );
	 source->active = 0;
      }
      else if (acl->pass == NULL)
      {
         ufdbLogMessage( "source \"%s\" has an empty \"pass\" in its ACL *****", source->name );
      }
   }

   for (cat = Cat;  cat != NULL;  cat = cat->next)
   {
      if (cat->options == 0  &&  cat->domainlist == NULL  &&  cat->execdomainlist == NULL  && 
          cat->expressionlist == NULL  &&  cat->rewrite == NULL  &&  cat->name != NULL)
      {
         ufdbLogError( "category \"%s\" has no content definition  *****", cat->name );
      }
   }

   if (UFDBglobalAdminEmail != NULL  &&  UFDBglobalEmailServer == NULL)
   {
      ufdbLogError( "No email server is defined; cannot send email to \"%s\"  *****", UFDBglobalAdminEmail );
   }
   if (UFDBglobalAdminEmail != NULL  &&  UFDBglobalEmailServer != NULL  &&  UFDBglobalSenderEmail == NULL)
   {
      ufdbLogMessage( "WARNING: No sender email address is defined; using \"%s\" as sender", UFDBglobalAdminEmail );
   }

   if (strncmp( UFDBglobalSquidVersion, "4.", 2 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "3.5", 3 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "3.4", 3 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "3.3", 3 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "3.2", 3 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "3.1", 3 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "3.0", 3 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "2.7", 3 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "2.6", 3 ) != 0)
   {
      ufdbLogFatalError( "Unsupported Squid version \"%s\"  *****\n"
                         "The supported values for squid-version are: 4.x, 3.5, 3.4, 3.3, 3.2, 3.1, 3.0, 2.7, 2.6  *****\n"
			 "If the version of Squid is higher, it is recommended to upgrade ufdbGuard.  *****\n"
			 "Alternatively set squid-version to the highest supported version",
			 UFDBglobalSquidVersion );
   }
   if (strncmp( UFDBglobalSquidVersion, "4.", 2 ) == 0  ||  strncmp( UFDBglobalSquidVersion, "3.5", 3 ) == 0  ||  strncmp( UFDBglobalSquidVersion, "3.4", 3 ) == 0)
      UFDBglobalSquidHelperProtocol = UFDB_SQUID_HELPER_PROTOCOL3;
   else if (strncmp( UFDBglobalSquidVersion, "2.6", 3 ) == 0  ||  strncmp( UFDBglobalSquidVersion, "2.7", 3 ) == 0)
      UFDBglobalSquidHelperProtocol = UFDB_SQUID_HELPER_PROTOCOL1;
   else
      UFDBglobalSquidHelperProtocol = UFDB_SQUID_HELPER_PROTOCOL2;	/* 3.0 - 3.3 */

   BuildImplicitPassLists();

   return 1;
}


static void setRefreshUserlist( int nmin )
{
   if (nmin < 5  ||  nmin > 24*60)
   {
      ufdbLogError( "refreshuserlist must have a value between 5 and %d, resetting to %d.", 24*60, UFDB_DEFAULT_REFRESH_USERLIST );
      nmin = UFDB_DEFAULT_REFRESH_USERLIST;
   }
   UFDBglobalRefreshUserlistInterval = nmin;
}


static void setRefreshDomainlist( int nmin )
{
   if (nmin < 5  ||  nmin > 24*60)
   {
      ufdbLogError( "refreshdomainlist must have a value between 5 and %d, resetting to %d.", 24*60, UFDB_DEFAULT_REFRESH_DOMAINLIST );
      nmin = UFDB_DEFAULT_REFRESH_DOMAINLIST;
   }
   UFDBglobalRefreshDomainlistInterval = nmin;
}


/*
 * Source functions
 */

void defSource( 
   char *          source )
{
   struct Source * sp;

   if (UFDBglobalDebug)
      ufdbLogMessage( "defSource: defining source \"%s\"", source );

   if ((struct Source *) defSourceFindName(source) != NULL)
   {
      ufdbLogFatalError( "line %d: source %s is already defined in configuration file %s",
			 lineno, source, UFDBglobalConfigFile );
      ufdbFree( source );
      return;
   }

   sp = (struct Source *) ufdbMallocAligned( 64, sizeof(struct Source) );
   sp->name = source;
   sp->active = 1;
   sp->evaluationMethod = UFDB_EVAL_OR;
   sp->ip = NULL;
   sp->lastip = NULL;
   sp->domainDb = NULL;
   sp->userDb = NULL;
   sp->time = NULL;
   sp->within = UFDB_ACL_NONE;
   sp->cont_search = 0;
   sp->sarg0 = NULL;
   sp->userquota.seconds = 0;
   sp->userquota.renew = 0;
   sp->userquota.sporadic = 0;
   sp->next = NULL;
   sp->nblocks = 0;
   sp->nmatches = 0;

   if (UFDBgetSourceList() == NULL)
   {
      if (UFDBglobalDebug)
         ufdbLogMessage( "defSource: SourceList is set to point to \"%s\"", source );
      UFDBsetSourceList( sp );
      lastSource = sp;
   }
   else
   {
      lastSource->next = sp;
      lastSource = sp;
   }
}


void defSourceEnd( void )
{
   struct Source * s;

   s = lastSource;
   if (s->ip == NULL  &&  s->domainDb == NULL  &&  s->userDb == NULL)
   {
      ufdbLogError( "source \"%s\" missing active content, set inactive  *****", s->name );
      s->time = NULL;
      s->active = 0;
   }
}


void ufdbSourceUser( 
   char *               user )
{
   char *               lc;
   struct Source *      sp;

   sp = lastSource;
   if (sp->userDb != NULL  &&  sp->userDb->type != SGDBTYPE_USERLIST)
   {
      ufdbLogFatalError( "user \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec userlists", 
                         user, sp->name, lineno );
      return;
   }
   if (sp->userDb == NULL)
   {
      sp->userDb = (struct sgDb *) ufdbMalloc( sizeof(struct sgDb) );
      sp->userDb->dbhome = NULL;
      sp->userDb->dbcp = (void *) UFDBmemDBinit();
      sp->userDb->type = SGDBTYPE_USERLIST;
      sp->userDb->entries = 0;
   }

   for (lc = user; *lc != '\0'; lc++)    /* convert username to lowercase chars */
   {
      if (*lc <= 'Z'  &&  *lc >= 'A')
         *lc += 'a' - 'A';
   }

   if (UFDBglobalDebug)
      ufdbLogMessage( "ufdbSourceUser: adding user \"%s\"", user );

   sp->userDb->entries++;
   UFDBmemDBinsert( (struct UFDBmemDB *) sp->userDb->dbcp, user, NULL );
   ufdbFree( user );
}


static void ufdbSourceUnixGroup(
   char *          groupName  )
{
   struct Source * sp;
   struct group *  grp;
   int             n;
   char *          user;

   sp = lastSource;
   if (sp->userDb != NULL  &&  sp->userDb->type != SGDBTYPE_USERLIST)
   {
      ufdbLogFatalError( "unix group \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec userlists", 
                         groupName, sp->name, lineno );
      return;
   }
   if (sp->userDb == NULL) 
   {
      sp->userDb = (struct sgDb *) ufdbMalloc( sizeof(struct sgDb) );
      sp->userDb->dbhome = NULL;
      sp->userDb->dbcp = (void *) UFDBmemDBinit();
      sp->userDb->type = SGDBTYPE_USERLIST;
      sp->userDb->entries = 0;
   }
 
   n = 0;
   setgrent();
   errno = 0;
   grp = getgrnam( groupName );
   if (grp != NULL)
   {
      if (UFDBglobalDebug > 1)
         ufdbLogMessage( "found group \"%s\"", grp->gr_name );

      while ((user = grp->gr_mem[n]) != NULL)
      {
	 char * lc;

	 if (UFDBglobalDebug > 1)
	    ufdbLogMessage( "group \"%s\" has user \"%s\"", grp->gr_name, user );
	 for (lc = user; *lc != '\0'; lc++)  	/* convert username to lowercase chars */
	 {
	    if (*lc <= 'Z'  &&  *lc >= 'A')
	       *lc += 'a' - 'A';
	 }
	 UFDBmemDBinsert( (struct UFDBmemDB *) sp->userDb->dbcp, user, NULL );
	 sp->userDb->entries++;
	 n++;
      }
      ufdbLogMessage( "source \"%s\": unix group \"%s\" has %d members", sp->name, groupName, n );
      if (n == 0)
	 ufdbLogMessage( "WARNING: source \"%s\": \"%s\" is an empty group  +++++", sp->name, groupName );
   }
   else
   {
      ufdbLogFatalError( "source \"%s\": \"%s\" is not a unix group", sp->name, groupName );
      if (errno)
	 ufdbLogError( "ufdbSourceUnixGroup: getgrnam returned error %d: %s", errno, strerror(errno) );
   }
   endgrent();
}


static void ufdbSourceGroup( 
   int    groupType,
   char * groupName  )
{
   switch (groupType)
   {
   case UFDB_GROUPTYPE_UNIX:
      ufdbSourceUnixGroup( groupName );
      break;
   default:     
      ufdbLogFatalError( "ufdbSourceGroup: unknown group type %d", groupType );
   }

   ufdbFree( groupName );
}


struct sgDb * UFDBretrieveExecDomainlist( struct Category * cat )
{
   char *        t;
   FILE *        fp;
   struct sgDb * newdb;
   int           exitcode;
   struct stat   Stat0;
   struct stat   Stat1;
   char          line[1024];
   char          basefilename[1024];
   char          fullfilename[1024];
   char          command[3000];

   if (cat == NULL)
   {
      ufdbLogFatalError( "UFDBretrieveExecDomainlist: category is NULL" );
      return NULL;
   }

   if (cat->domainlist == NULL)
   {
      ufdbLogError( "will not execute command for category %s since domainlist is undefined", cat->name );
      return NULL;
   }

   if (cat->execdomainlist == NULL)
   {
      ufdbLogError( "can't execute command for category %s since execdomainlist is undefined", cat->name );
      return NULL;
   }

   if (cat->domainlist[0] == '/')
   {
      strcpy( basefilename, cat->domainlist );
   }
   else
   {
      char * dbhome;
      dbhome = ufdbSettingGetValue( "dbhome" );
      if (dbhome == NULL)
	 dbhome = (char *) DEFAULT_DBHOME;
      sprintf( basefilename, "%s/%s", dbhome, cat->domainlist );
   }
   strcpy( fullfilename, basefilename );
   strcat( fullfilename, UFDBfileSuffix );

   if (stat( fullfilename, &Stat0 ) != 0)
   {
      Stat0.st_mtime = 0;
      ufdbLogMessage( "category %s: pre-execdomainlist: domainlist does not exist (%s)", cat->name, fullfilename );
   }

   /* The script that we will call needs the directory where the files reside,
    * so we set the environment variable UFDB_TABLEDIR for it to change its working directory.
    * (note that we are multithreaded and cannot use chdir() here)
    */
   strcpy( command, "cd " );
   strcat( command, basefilename );
   t = strrchr( command, '/' );
   if (t != NULL)
      *t = '\0';
   strcat( command, " ; " );
   strcat( command, cat->execdomainlist );

   errno = 0;
   if ((fp = popen(command,"r")) == NULL)
   {
      ufdbLogFatalError( "category %s: can't execute command of execdomainlist \"%s\": popen failed: %s  *****", 
                         cat->name, cat->execdomainlist, strerror(errno) );
      return NULL;
   }

   while (UFDBfgetsNoNL(line,sizeof(line),fp) != NULL)
   {
      ufdbLogMessage( "execdomainlist for %s produced: %s", cat->name, line );
   }
   errno = 0;
   exitcode = pclose( fp );

   if (exitcode == -1  &&  errno == ECHILD)
      exitcode = 0;
      /* most likely the child handler thread already did a wait() */

   if (exitcode == 0)
   {
      if (UFDBglobalDebug || UFDBglobalDebugExternalScripts)
         ufdbLogMessage( "   execdomainlist for %s: exit 0 (OK)", cat->name );
   }
   else if (exitcode == -1)
   {
      ufdbLogError( "execdomainlist for %s: pclose error: %d (%s)", cat->name, errno, strerror(errno) );
      return NULL;
   }
   else if (exitcode > 0)
   {
      ufdbLogError( "execdomainlist for %s: command (%s) terminated with an error exit code %d", 
                    cat->name, cat->execdomainlist, exitcode );
      return NULL;
   }

   /* The command defined by 'execdomainlist' has been executed and the exit code was 0 (OK), so
    * now it is verified if the file timestamp of domains.ufdb is newer.
    */

   if (stat( fullfilename, &Stat1 ) != 0)
   {
      ufdbLogError( "execdomainlist for %s: command failed to produce a .ufdb file (%s)", cat->name, fullfilename );
      return NULL;
   }

   newdb = (struct sgDb *) ufdbCalloc( sizeof(struct sgDb), 1 );
   newdb->dbhome = NULL;
   newdb->dbcp = NULL;
   newdb->type = SGDBTYPE_DOMAINLIST;

   sgDbInit( newdb, basefilename );
   if (newdb->dbcp == NULL)
   {
      ufdbLogError( "execdomainlist for %s: command produced a .ufdb file but I failed to load it", cat->name );
      ufdbFree( newdb );
      return NULL;
   }

   if (UFDBglobalDebug || UFDBglobalDebugExternalScripts)
      ufdbLogMessage( "execdomainlist for %s: new URL table is loaded", cat->name );

   return newdb;
}


void ufdbSourceExecUserList(
   char *          command )
{
   time_t          t0, te;
   struct Source * sp;

   /* execuserlist is used to dynamically retrieve a list of usernames and
    * is executed every 15 minutes to refresh the list of usernames.
    */

   sp = lastSource;
   if (sp->userDb != NULL  &&  sp->userDb->type != SGDBTYPE_EXECUSERLIST)
   {
      ufdbLogFatalError( "execuserlist \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec userlists", 
                         command, sp->name, lineno );
      return;
   }
   if (sp->userDb != NULL)
   {
      ufdbLogFatalError( "execuserlist \"%s\" in source \"%s\" on line %d: "
                         "more than one execuserlist is not supported.  Merge the userlists in the script.", 
                         command, sp->name, lineno );
      return;
   }
   ufdbLogMessage( "execuserlist \"%s\"", command );

   t0 = time( NULL );
   sp->userDb = UFDBretrieveExecUserlist( command );
   sp->sarg0 = command;				/* command is already malloc-ed */
   te = time( NULL );

   if (te - t0 > 6)
      ufdbLogMessage( "WARNING: it took %ld seconds to execute \"%s\"", te - t0, command );
 
   if (UFDBglobalDebug || UFDBglobalDebugExternalScripts)
   {
      UFDBmemDBprintUserDB( "user", (struct UFDBmemDB *) sp->userDb->dbcp );
   }
}


void ufdbSourceUserList( 
   char * file  )
{
   char * dbhome;
   char * f;
   FILE * fp;
   char * p;
   char * c;
   char * s;
   char * lc;
   char * lineptr;
   int    ullineno;
   struct sgDb * udb;
   struct Source * sp;
   char   line[10000];
 
   sp = lastSource;
   if (UFDBglobalDebug)
      ufdbLogMessage( "ufdbSourceUserList: source \"%s\"  file \"%s\"", 
       		      sp->name != NULL ? sp->name : "nosource", file );
   udb = sp->userDb;
   if (udb != NULL  &&  udb->type != SGDBTYPE_USERLIST)
   {
      ufdbLogFatalError( "userlist \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec userlists", 
                         file, sp->name, lineno );
      return;
   }
   if (udb == NULL)
   {
      udb = sp->userDb = (struct sgDb *) ufdbMalloc( sizeof(struct sgDb) );
      udb->dbhome = NULL;
      udb->dbcp = (void *) UFDBmemDBinit();
      udb->type = SGDBTYPE_USERLIST;
      udb->entries = 0;
   }
 
   dbhome = ufdbSettingGetValue( "dbhome" );
   if (dbhome == NULL)
      dbhome = (char *) DEFAULT_DBHOME;
 
   if (file[0] == '/')
      f = file;
   else
   {
      f = (char *) ufdbMalloc( strlen(dbhome) + strlen(file) + 2 );
      strcpy( f, dbhome );
      strcat( f, "/" );
      strcat( f, file );
      ufdbFree( file );
   }
 
   if ((fp = fopen(f,"r")) == NULL)
   {
      ufdbLogError( "line %d: can't open userlist %s: %s  *****", lineno, f, strerror(errno) );
      ufdbFree( f );
      return;
   }
   ullineno = 0;
 
   ufdbLogMessage( "userlist \"%s\"", f );
 
   while (fgets(line,sizeof(line),fp) != NULL)
   {
      ullineno++;
      if (line[0] == '#')			/* skip comments */
         continue;
 
      p = strchr( line, '\n' );
      if (p != NULL)
      {
         *p = '\0';
         if (p != line) 
         {
  	    if (*(p - 1) == '\r') 		/* remove ^M  */
  	       *(p-1) = '\0';
         }
      }
  
      if (line[0] == '\0')
      {
         ufdbLogError( "userlist %s: line %d: line is empty", f, ullineno );
         continue;
      }
  
      c = strchr( line, '#' );		/* remove comment */
      if (c != NULL)
         *c = '\0';
  
      p = strtok_r( line, " \t,", &lineptr );
      if (p == NULL  ||  *p == '\0')
         continue;
  
      /* we may have a passwd-style formatted file. Ignore ':' and everything else that follows. */
      if ((s = strchr(p,':')) != NULL) 
         *s = '\0';
  
      do
      {
         for (lc = p;  *lc != '\0';  lc++)   /* convert username to lowercase chars */
         {
  	    if (*lc <= 'Z'  &&  *lc >= 'A')
  	       *lc += 'a' - 'A';
         }
         if (*p != '\0')
 	 {
	    udb->entries++;
  	    UFDBmemDBinsert( (struct UFDBmemDB *) udb->dbcp, p, NULL );
         }
      } while ((p = strtok_r(NULL," \t,",&lineptr)) != NULL  &&  *p != '\0');
   }
   fclose( fp );

   if (UFDBglobalDebug)
   {
      ufdbLogMessage( "just read userlist \"%s\"", f );
      UFDBmemDBprintUserDB( "user", (struct UFDBmemDB *) udb->dbcp );
   }

   ufdbFree( f );
}


static void ufdbSourceUserQuota( 
   const char * seconds, 
   const char * sporadic,  
   const char * renew )
{
   int    s;
   struct UserQuota * uq;
   struct Source * sp;
 
   sp = lastSource;
   uq = &sp->userquota;
   s = atoi( seconds );
   if (s <= 0)
      ufdbLogError( "line %d: userquota seconds sporadic hourly|daily|weekly", lineno );
   uq->seconds = s; 
   s = atoi( sporadic );
   if (s <= 0)
      ufdbLogError( "line %d: userquota seconds sporadic hourly|daily|weekly", lineno );
   uq->sporadic = s; 
   s = atoi( renew );
   if (s <= 0)
      ufdbLogError( "line %d: userquota seconds sporadic hourly|daily|weekly", lineno );
   uq->renew = s;
}


void defSourceDomain( 
   char * domain )
{
   struct Source * sp;

   sp = lastSource;
   if (sp->domainDb == NULL) 
      sp->domainDb = (struct sgDb *) UFDBmemDBinit();

   if (UFDBglobalDebug)
      ufdbLogMessage( "defSourceDomain \"%s\"", domain );

   UFDBmemDBinsert( (struct UFDBmemDB *) sp->domainDb, domain, NULL );

   ufdbFree( domain );
}


void ufdbSourceEval( 
   int method  )
{
   if (lastSource != NULL)
   {
      if (UFDBglobalDebug)
         ufdbLogMessage( "ufdbSourceEval %d: %s", method, 
	                 method == UFDB_EVAL_OR ? "evaluate-or" : "evaluate-and" );
      lastSource->evaluationMethod = method;
   }
}


void defSourceTime( 
   char *         name, 
   int            within )
{
   struct ufdbTime *  t;

   if ((t = sgTimeFindName(name)) == NULL)
   {
      ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
		         lineno, name, UFDBglobalConfigFile );
      ufdbFree( name );
      return;
   }

   lastSource->within = within;
   lastSource->time = t;
   ufdbFree( name );
}


struct Source * defSourceFindName( 
   char *          name )
{
   struct Source * p;

   for (p = UFDBgetSourceList();  p != NULL;  p = p->next)
   {
      if (strcmp(name,p->name) == 0)
         return p;
   }

   return NULL;
}


void defSourceIpList( 
  char * file )
{
  char * dbhome = NULL;
  char * f;
  FILE * fp;
  char * p;
  char * c;
  char * cidr;
  int    i;
  int    l = 0;
  char * lineptr;
  char   line[UFDB_MAX_URL_LENGTH];

  dbhome = ufdbSettingGetValue( "dbhome" );
  if (dbhome == NULL)
    dbhome = (char *) DEFAULT_DBHOME;

  if (file[0] == '/') 
  {
    f = file;
  }
  else
  {
    f = (char *) ufdbMalloc( strlen(dbhome) + strlen(file) + 2 );
    strcpy( f, dbhome );
    strcat( f, "/" );
    strcat( f, file );
    ufdbFree( file );
  }

  if ((fp = fopen(f,"r")) == NULL) 
  {
    ufdbLogError( "line %d: can't open iplist %s: %s", lineno, f, strerror(errno) );
    ufdbFree( f );
    return;
  }

  ufdbLogMessage( "iplist \"%s\"", file );

  while (fgets(line,sizeof(line),fp) != NULL)
  {
    l++;
    if (*line == '#')
      continue;
    p = strchr( line, '\n' );
    if (p != NULL && p != line) 
    {
      if (*(p - 1) == '\r') 		/* removing ^M  */
	p--;
      *p = '\0';
    }
    c = strchr( line, '#' );
    p = strtok_r( line, " \t,", &lineptr );
    do {
      if (c != NULL && p >= c) 		/* find the comment */
	break;
      i = strspn( p, ".0123456789/-" );
      if (i == 0)
	break;
      *(p + i) = '\0';
      if ((cidr = strchr(p,'/')) != NULL) 
      {
	*cidr = '\0';
	cidr++;
	sgIp( p );
	sgIp( cidr );
	if (strchr(cidr,'.') == NULL)
	  sgSetIpType( SG_IPTYPE_CIDR, f, l );
	else 
	  sgSetIpType( SG_IPTYPE_CLASS, f, l );
      }
      else if ((cidr = strchr(p,'-')) != NULL) 
      {
	*cidr = '\0';
	cidr++;
	sgIp( p );
	sgIp( cidr );
	sgSetIpType( SG_IPTYPE_RANGE, f, l );
      }
      else
      {
	sgIp( p );
	sgIp( ufdbStrdup("255.255.255.255") );
	sgSetIpType( SG_IPTYPE_HOST, f, l );
      }
    } while ((p = strtok_r(NULL," \t,",&lineptr)) != NULL);
  }

  fclose( fp );
  ufdbFree( f );
}


/* category block functions */

void ufdbCategory( 
  char *            cat )
{
  struct Category * sp;

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbCategory %s", cat );
#endif

  if (Cat != NULL) 
  {
    if ((struct Category *) ufdbCategoryFindName(cat) != NULL)
    {
      ufdbLogFatalError( "line %d: category %s is already defined in configuration file %s",
		         lineno, cat, UFDBglobalConfigFile );
      ufdbFree( cat );
      return;
    }
  }

  sp = (struct Category *) ufdbMallocAligned( 64, sizeof(struct Category) );
  sp->active = 1;
  sp->options = 0;
  sp->within = UFDB_ACL_NONE;
  sp->blockBumpedConnect = 0;
  sp->name = cat;
  sp->domainlist = NULL;
  sp->domainlistDb = NULL;
  sp->execdomainlist = NULL;
  sp->expressionlist = NULL;
  sp->regExp = NULL;
  sp->redirect = NULL;
  sp->time = NULL;
  sp->rewrite = NULL;
  sp->cse = NULL;
  sp->cse2 = NULL;
  sp->next = NULL;
  sp->nblocks = 0;
  sp->nmatches = 0;

  if (Cat == NULL) {
    Cat = sp;
    lastCat = sp;
  } else {
    lastCat->next = sp;
    lastCat = sp;
  }

   /* category "security" is a special case: the options cannot be set default to 0
    * because the default value for allow-unknown-protocol-over-https is ON.
    */
   if (strcmp( cat, "security" ) == 0)
      sp->options = UFDB_OPT_UNKNOWN_PROTOCOL_OVER_HTTPS;
}


void ufdbCategoryEnd( void )
{
  struct Category * d;
 
  d = lastCat;
  if (d->domainlist == NULL  &&  d->expressionlist == NULL  && 
      d->redirect == NULL  &&  d->rewrite == NULL  &&
      d->options == 0)
  {
    ufdbLogError( "category \"%s\" is missing content, set inactive  *****", d->name );
    d->time = NULL;
    d->active = 0;
  }
}


void ufdbCategoryOption( int value, int option )
{
   struct Category * sp;

   sp = lastCat;
   if (value)
      sp->options = sp->options | option;
   else
      sp->options = sp->options & (~option);

   if (option == UFDB_OPT_HTTPS_WITH_HOSTNAME)
      UFDBglobalHttpsWithHostname = value;
   else if (option == UFDB_OPT_HTTPS_OFFICAL_CERTIFICATE)
      UFDBglobalHttpsOfficialCertificate = value;
   else if (option == UFDB_OPT_SKYPE_OVER_HTTPS)
      UFDBglobalSkypeOverHttps = value;
   else if (option == UFDB_OPT_GTALK_OVER_HTTPS)
      UFDBglobalGtalkOverHttps = value;
   else if (option == UFDB_OPT_YAHOOMSG_OVER_HTTPS)
      UFDBglobalYahooMsgOverHttps = value;
   else if (option == UFDB_OPT_AIM_OVER_HTTPS)
      UFDBglobalAimOverHttps = value;
   else if (option == UFDB_OPT_FBCHAT_OVER_HTTPS)
      UFDBglobalFBchatOverHttps = value;
   else if (option == UFDB_OPT_CITRIXONLINE_OVER_HTTPS)
      UFDBglobalCitrixOnlineOverHttps = value;
   else if (option == UFDB_OPT_ANYDESK_OVER_HTTPS)
      UFDBglobalAnydeskOverHttps = value;
   else if (option == UFDB_OPT_TEAMVIEWER_OVER_HTTPS)
      UFDBglobalTeamviewerOverHttps = value;
   else if (option == UFDB_OPT_PROHIBIT_INSECURE_SSLV2)
      UFDBglobalHttpsNoSSLv2 = value;
   else if (option == UFDB_OPT_PROHIBIT_INSECURE_SSLV3)
      UFDBglobalHttpsNoSSLv3 = value;
   else if (option == UFDB_OPT_UNKNOWN_PROTOCOL_OVER_HTTPS)
      UFDBglobalUnknownProtocolOverHttps = value;
   else if (option == UFDB_OPT_SAFE_SEARCH)
      ;
   else if (option == UFDB_OPT_YOUTUBE_EDUFILTER)
      ;
   else
      ufdbLogError( "ufdbCategoryOption: unrecognised option %d *****", option );

   if (UFDBglobalDebug)
      ufdbLogMessage( "ufdbCategoryOption: %s: option %d set to %d", sp->name, option, value );
}


void ufdbCategoryDomainList( 
  char * domainlist )
{
  struct Category * sp;
  char * dbhome;
  char * dl = domainlist;
  char * name;

  if (UFDBglobalDebug > 1)
     ufdbLogMessage( "ufdbCategoryDomainList %s", domainlist );

  if (UFDBglobalTerminating)
     return;

  sp = lastCat;
  dbhome = ufdbSettingGetValue("dbhome");
  if (dbhome == NULL)
    dbhome = (char *) DEFAULT_DBHOME;

  if (domainlist == NULL)
  {
    name = sp->name;
    dl = (char *) ufdbMalloc( sizeof("/dest/") + strlen(name) + sizeof("/domainlist") + 2 );
    strcpy(dl,"/dest/");
    strcat(dl,name);
    strcat(dl,"/domainlist");

    sp->domainlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(dl) + 2 );
    strcpy(sp->domainlist,dbhome);
    strcat(sp->domainlist,"/");
    strcat(sp->domainlist,dl);
  }
  else
  {
    if (domainlist[0] == '/') 
      sp->domainlist = domainlist;
    else
    {
       sp->domainlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(domainlist) + 2 );
       strcpy( sp->domainlist, dbhome );
       strcat( sp->domainlist, "/" );
       strcat( sp->domainlist, domainlist );
       ufdbFree( domainlist );
    }
  }

  sp->domainlistDb = (struct sgDb *) ufdbCalloc( 1, sizeof(struct sgDb) );
  sp->domainlistDb->type = SGDBTYPE_DOMAINLIST;
  sgDbInit( sp->domainlistDb, sp->domainlist );
  ufdbLogMessage( "loading URL table from \"%s\"", sp->domainlist );
  if (sp->domainlistDb->dbcp == NULL  ||
      ((struct UFDBmemTable *) sp->domainlistDb->dbcp)->table.nNextLevels == 0)
  {
    ufdbLogError( "URL database table \"%s\" is empty and is ignored   *****", sp->domainlist );
    ufdbFreeDomainDb( sp->domainlistDb );
    sp->domainlistDb = NULL;
  }
}


void ufdbCategoryExecDomainList( 
   char * command )
{
   struct Category * sp;

   if (UFDBglobalTerminating)
      return;

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbCategoryExecDomainList %s", command );
#endif

   sp = lastCat;

   if (sp == NULL)
   {
      ufdbLogFatalError( "execdomainlist is not within a URL category" );
      return;
   }
   sp->execdomainlist = command;

   if (UFDBglobalDebug)
      ufdbLogMessage( "execdomainlist for category %s: \"%s\"", sp->name, command );
}


void ufdbFreeDomainDb( 
   struct sgDb * dbp )
{
   struct UFDBmemTable * mt;

   if (dbp == NULL)
      return;

   mt = (struct UFDBmemTable *) dbp->dbcp;
   if (mt != NULL)
   {
      if (mt->index != NULL)
	 ufdbFree( mt->index );				/* version 2.x */
      else
	 UFDBfreeTableIndex_1_2( &(mt->table) ); 	/* version 1.2 */
      ufdbFree( (void *) mt->mem );
      ufdbFree( mt );
   }
   ufdbFree( dbp );
}


void ufdbFreeIpList( struct Ip * p )
{
   struct Ip * tmp;

   while (p != NULL)
   {
      ufdbFree( p->str );
      tmp = p->next;
      ufdbFree( p );
      p = tmp;
   }
}


void ufdbFreeSourceList( struct Source * p )
{
   struct Source * tmp;

   while (p != NULL)
   {
      ufdbFreeIpList( p->ip );
      ufdbFree( p->name );
      if (p->domainDb != NULL)
	 UFDBmemDBdeleteDB( (struct UFDBmemDB *) p->domainDb );

      /* execuserlist content is saved during a reload */
      if (p->userDb != NULL  &&  p->userDb->type != SGDBTYPE_EXECUSERLIST)
      {
	 UFDBmemDBdeleteDB( (struct UFDBmemDB *) p->userDb->dbcp );
	 ufdbFree( p->userDb );
      }
      ufdbFree( p->sarg0 );

      tmp = p->next;
      ufdbFree( p );
      p = tmp;
   }
}


void ufdbFreeAclCategoryList( struct AclCategory * p )
{
   struct AclCategory * tmp;

   while (p != NULL)
   {
      ufdbFree( p->name );
      tmp = p->next;
      ufdbFree( p );
      p = tmp;
   }
}


void ufdbFreeAclList( struct Acl * p )
{
   struct Acl * tmp;

   while (p != NULL)
   {
      ufdbFree( p->name );
      ufdbFreeAclCategoryList( p->pass );
      ufdbFreeAclCategoryList( p->implicitPass );
      ufdbFree( p->redirect );
      tmp = p->next;
      ufdbFree( p );
      p = tmp;
   }
}


void ufdbFreeSettingList( struct ufdbSetting * p )
{
   struct ufdbSetting * tmp;
 
   while (p != NULL)
   {
      ufdbFree( p->name );
      ufdbFree( p->value );
      tmp = p->next;
      ufdbFree( p );
      p = tmp;
   }
}


static void ufdbFreeCategoryDomainList( struct Category * p )
{
   struct Category * tmp;

   while (p != NULL)
   {
      ufdbFree( p->name );
      ufdbFree( p->domainlist );
      ufdbFreeDomainDb( p->domainlistDb );
      ufdbFree( p->execdomainlist );
      ufdbFree( p->cse );
      ufdbFree( p->cse2 );
      ufdbFree( p->expressionlist );
      ufdbFreeRegExprList( p->regExp );
      ufdbFree( p->redirect );
      /* ufdbFree( p->rewrite );  freed in ufdbFreeRewriteList() */
      tmp = p->next;
      ufdbFree( p );
      p = tmp;
   }
}


void ufdbFreeRewriteList( 
   struct sgRewrite * p )
{
   struct sgRewrite * tmp;

   while (p != NULL)
   {
      ufdbFreeRegExprList( p->rewrite );
      ufdbFree( p->name );
      tmp = p->next;
      ufdbFree( p );
      p = tmp;
   }
}


void ufdbFreeTimeElement( 
   struct TimeElement * p )
{
   struct TimeElement * tmp;

   while (p != NULL)
   {
      tmp = p->next;
      ufdbFree( p );
      p = tmp;
   }
}


void ufdbFreeTime( 
   struct ufdbTime * p )
{
   struct ufdbTime * tmp;

   while (p != NULL)
   {
      ufdbFree( p->name );
      ufdbFreeTimeElement( p->element );
      tmp = p->next;
      ufdbFree( p );
      p = tmp;
   }
}


void ufdbFreeAllMemory( void )
{
#if 0
   /* we cannot stop using the log file. we never close it */
   if (UFDBglobalLogDir != NULL)
      ufdbFree( UFDBglobalLogDir );
   UFDBglobalLogDir = NULL;
   globalLogFile = NULL;
#endif

   if (UFDBglobalPidFile != NULL)
   {
      ufdbFree( UFDBglobalPidFile );
      UFDBglobalPidFile = NULL;
   }
   if (UFDBglobalEmailServer != NULL)
   {
      ufdbFree( UFDBglobalEmailServer );
      UFDBglobalEmailServer = NULL;
   }
   if (UFDBglobalMyHostname != NULL)
   {
      ufdbFree( UFDBglobalMyHostname );
      UFDBglobalMyHostname = NULL;
   }
   if (UFDBglobalAdminEmail != NULL)
   {
      ufdbFree( UFDBglobalAdminEmail );
      UFDBglobalAdminEmail = NULL;
   }
   if (UFDBglobalSenderEmail != NULL)
   {
      ufdbFree( UFDBglobalSenderEmail );
      UFDBglobalSenderEmail = NULL;
   }
   if (UFDBglobalExternalStatusCommand != NULL)
   {
      ufdbFree( UFDBglobalExternalStatusCommand );
      UFDBglobalExternalStatusCommand = NULL;
   }

   ufdbFreeSettingList( Setting );
   ufdbFreeRewriteList( Rewrite );
   ufdbFreeCategoryDomainList( Cat );
   ufdbFreeAclList( AclList );

   ufdbFreeSourceList( (struct Source *) SourceList );
   UFDBsetSourceList( NULL );
   lastSource = NULL;

   /* free UFDBglobalCheckedDB */
   if (UFDBglobalCheckedDB.table.nNextLevels > 0  &&  UFDBglobalCheckedDB.mem != NULL)
   {
      if (UFDBglobalCheckedDB.index != NULL)
         ufdbFree( (void *) UFDBglobalCheckedDB.index );
      else
	 UFDBfreeTableIndex_1_2( &(UFDBglobalCheckedDB.table) ); 		/* .nextLevel[0]) ); */
      ufdbFree( (void *) UFDBglobalCheckedDB.mem );
   }
   UFDBglobalCheckedDB.table.nNextLevels = 0;
   UFDBglobalCheckedDB.mem = NULL;
   UFDBglobalCheckedDB.index = NULL;

   if (UFDBglobalCheckedExpressions != NULL)
   {
      ufdbFreeRegExprList( UFDBglobalCheckedExpressions );
      UFDBglobalCheckedExpressions = NULL;
   }

   lastSetting = NULL;
   Setting = NULL;

   lastCat = NULL;
   Cat = NULL;

   lastRewrite = NULL;
   Rewrite = NULL;
   lastRewriteRegExec = NULL;

   ufdbFreeTime( TimeList );
   TimeList = NULL;
   lastTime = NULL;

   ufdbFree( TimeElementsEvents );
   TimeElementsEvents = NULL;
   numTimeElements = 0;

   lastTimeElement = NULL;
   TimeElement = NULL;

   lastAcl = NULL;
   defaultAcl = NULL;
   AclList = NULL;
   lastAclCategory = NULL;

   lastRegExpDest = NULL;

   ufdbFree( UFDBglobalSquidVersion );
   UFDBglobalSquidVersion = NULL;
}


void ufdbCategoryUrlList( 
   char * urllist )
{
   if (urllist == NULL)
      urllist = (char *) "-";
   ufdbLogError( "line %d: \"urllist %s\" is deprecated and ignored *****\n"
                 "ufdbGenTable should be called with the -u option to include URLs\n"
		 "ufdbGenTable combines URLs and domains in one table file so only the domainlist is required",
		 lineno, urllist );
   if (urllist[0] != '-')
      ufdbFree( urllist );
}


void ufdbCategoryExpressionList( 
  char * exprlist, 
  const char * chcase  )
{
  FILE * fp;
  char * dbhome;
  char * dl;
  char * name;
  char * p;
  int    flags;
  struct stat         statbuf;
  struct Category *   sp;
  struct ufdbRegExp * regexp;
  char   buf[UFDB_MAX_URL_LENGTH];
  char   errbuf[256];

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbCategoryExpressionList %s", exprlist );
#endif

  if (UFDBglobalTerminating)
     return;

  flags = REG_EXTENDED | REG_NOSUB;
  dbhome = ufdbSettingGetValue( "dbhome" );
  sp = lastCat;
  if (dbhome == NULL)
    dbhome = (char *) DEFAULT_DBHOME;

  if (exprlist == NULL)
  {
    name = sp->name;
    dl = (char *) ufdbMalloc( sizeof("/dest/") + strlen(name) + sizeof("/expressionlist") + 2 );
    strcpy(dl,"/dest/");
    strcat(dl,name);
    strcat(dl,"/expressionlist");

    flags |= REG_ICASE; 	/* default case insensitive */

    sp->expressionlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(dl) + 2 );
    strcpy(sp->expressionlist,dbhome);
    strcat(sp->expressionlist,"/");
    strcat(sp->expressionlist,dl);
  }
  else
  {
    if (exprlist[0] == '/') 
    {
      sp->expressionlist = exprlist;
    }
    else
    {
       sp->expressionlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(exprlist) + 2 );
       strcpy( sp->expressionlist, dbhome );
       strcat( sp->expressionlist, "/" );
       strcat( sp->expressionlist, exprlist );
       ufdbFree( exprlist );
    }
    if (*chcase == 'i')
       flags |= REG_ICASE;     /* set case insensitive */
  }

  ufdbLogMessage( "loading regular expressions from \"%s\"", sp->expressionlist );

  if ((fp = fopen(sp->expressionlist, "r")) == NULL) 
  {
    ufdbLogFatalError( "cannot open expression list %s: %s", sp->expressionlist, strerror(errno) );
    return;
  }

  if (0 == fstat( fileno(fp), &statbuf ))
  {
     if (!S_ISREG(statbuf.st_mode))
     {
        ufdbLogFatalError( "expression list %s: not a regular file", sp->expressionlist );
	fclose( fp );
	return;
     }
  }

  while (!feof(fp)  &&  fgets(buf, sizeof(buf), fp) != NULL) 
  {
    if (buf[0] == '#')
       continue;

    p = (char *) strchr( buf, '\n' );
    if (p != NULL  &&  p != buf) 
    {
      if (*(p-1) == '\r') 	/* removing ^M  */
	p--;
      *p = '\0';
    }
    /* TO-DO: warn about leading and trailing spaces */
    regexp = ufdbNewPatternBuffer( buf, flags );
    if (regexp->error) 
    {
      regerror( regexp->error, regexp->compiled[0], errbuf, sizeof(errbuf) );
      ufdbLogError( "regular expression error in %s:\n%s: %s   *****", sp->expressionlist, errbuf, buf );
    }
    if (lastCat->regExp == NULL) 
    {
      lastCat->regExp = regexp;
      lastRegExpDest = regexp;
    }
    else
    {
      lastRegExpDest->next = regexp;
      lastRegExpDest = regexp;
    }
  }

  fclose( fp );

  if (UFDBglobalExpressionOptimisation)
     lastCat->regExp = UFDBoptimizeExprList( sp->expressionlist, lastCat->regExp );
}


void ufdbCategoryCACertsFile(
   char *              cacertsFile )
{
   struct Category *   cat;

   cat = lastCat;
   if (cat == NULL  ||  strcmp( cat->name, "security" ) != 0)
   {
      ufdbLogFatalError( "cacerts can only be defined inside the \"security\" category" );
      return;
   }

   cat->cse = cacertsFile;
   if (*cacertsFile == '/')
      strcpy( UFDBglobalCAcertsFile, cacertsFile );
   else
   {
      char * dbh;
      dbh = ufdbSettingGetValue( "dbhome" );
      if (dbh == NULL)
         dbh = (char *) DEFAULT_DBHOME;
      strcpy( UFDBglobalCAcertsFile, dbh );
      strcat( UFDBglobalCAcertsFile, "/" );
      strcat( UFDBglobalCAcertsFile, cacertsFile );
   }
}


void ufdbCategoryCACertsDir(
   char *              cacertsDir )
{
   struct Category *   cat;

   cat = lastCat;
   if (cat == NULL  ||  strcmp( cat->name, "security" ) != 0)
   {
      ufdbLogFatalError( "cacerts-dir can only be defined inside the \"security\" category" );
      return;
   }

   cat->cse2 = cacertsDir;
   if (*cacertsDir == '/')
      strcpy( UFDBglobalCAcertsDir, cacertsDir );
   else
   {
      char * dbh;
      dbh = ufdbSettingGetValue( "dbhome" );
      if (dbh == NULL)
        dbh = (char *) DEFAULT_DBHOME;
      strcpy( UFDBglobalCAcertsDir, dbh );
      strcat( UFDBglobalCAcertsDir, "/" );
      strcat( UFDBglobalCAcertsDir, cacertsDir );
   }
}


void ufdbCategoryRedirect( 
   char * value )
{
   struct Category * sp;

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbCategoryRedirect %s", value );
#endif

   sp = lastCat;
   sp->redirect = value;
   /* TODO: check that "localhost" is not here if no 302 is used */
}


void ufdbCategoryRewrite( 
  char *              value )
{
  struct sgRewrite *  rewrite;

  if ((rewrite = sgRewriteFindName(value)) == NULL)
  {
    ufdbLogFatalError( "line %d: rewrite %s is not defined in configuration file %s",
		       lineno, value, UFDBglobalConfigFile );
    return;
  }

  lastCat->rewrite = rewrite;
}


void ufdbCategoryBlockConnect( 
   int flag  )
{
   lastCat->blockBumpedConnect = flag;

   if (UFDBglobalDebug)
      ufdbLogMessage( "ufdbCategoryBlockConnect: category \"%s\" : block-bumped-connect %s",
                      lastCat->name, flag ? "on" : "off" );
}


void ufdbCategoryTime(  
  char *        name, 
  int  		within )
{
  struct ufdbTime * t;

  if ((t = sgTimeFindName(name)) == NULL) 
  {
    ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
		       lineno, name, UFDBglobalConfigFile );
    ufdbFree( name );
    return;
  }

  lastCat->within = within;
  lastCat->time = t;
  ufdbFree( name );
}


struct Category * ufdbCategoryFindName( 
  char *               name )
{
  struct Category * p;

  for (p = Cat; p != NULL; p = p->next)
  {
    if (strcmp(name,p->name) == 0)
      return p;
  }

  return NULL;
}


void sgRewrite( 
  char * rewrite )
{
  struct sgRewrite * rew;

#if UFDB_DEBUG
   ufdbLogMessage( "sgRewrite %s", rewrite );
#endif

  if (Rewrite != NULL)
  {
    if ((struct sgRewrite *) sgRewriteFindName(rewrite) != NULL)
    {
      ufdbLogFatalError( "line %d: rewrite \"%s\" is not defined in configuration file %s",
		       lineno, rewrite, UFDBglobalConfigFile );
      ufdbFree( rewrite );
      return;
    }
  }

  rew = (struct sgRewrite *) ufdbMalloc( sizeof(struct sgRewrite) );
  rew->name = rewrite;
  rew->active = 1;
  rew->rewrite = NULL;
  rew->time = NULL;
  rew->within = UFDB_ACL_NONE;
  rew->next = NULL;

  if (Rewrite == NULL) 
  {
    Rewrite = rew;
    lastRewrite = rew;
  }
  else
  {
    lastRewrite->next = rew;
    lastRewrite = rew;
  }
}


void sgRewriteTime( 
  char * name, 
  int    within )
{
  struct ufdbTime * t;

#if UFDB_DEBUG
   ufdbLogMessage( "sgRewriteTime %s %d", name, within );
#endif

  if ((t = sgTimeFindName(name)) == NULL)
  {
    ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
		       lineno, name, UFDBglobalConfigFile );
    ufdbFree( name );
    return;
  }

  lastRewrite->within = within;
  lastRewrite->time = t;
  ufdbFree( name );
}


void sgRewriteSubstitute( 
  char * string )
{
  char * pattern; 
  char * subst = NULL;
  char * p;
  int    flags = REG_EXTENDED;
  int    global = 0;
  char * httpcode = NULL;
  struct ufdbRegExp * regexp;
  char   errbuf[256];

  pattern = string + 2; 	/* skipping s@ */
  p = pattern;
  while ((p = strchr(p,'@')) != NULL)
  {
    if (*(p - 1) != '\\') 
    {
      *p = '\0';
      subst = p + 1;
      break;
    }
    p++;
  }

  p = strrchr( subst, '@' );
  while (p != NULL  &&  *p != '\0')
  {
    if (*p == 'r' )
      httpcode =  (char *) REDIRECT_TEMPORARILY;
    if (*p == 'R' )
      httpcode =  (char *) REDIRECT_PERMANENT;
    if (*p == 'i' || *p == 'I')
      flags |= REG_ICASE;
    if (*p == 'g')
      global = 1;
    *p = '\0'; 		/* removes @i from string */
    p++;
  } 

  regexp = ufdbNewPatternBuffer( pattern, flags );
  if (regexp->error) 
  {
      regerror( regexp->error, regexp->compiled[0], errbuf, sizeof(errbuf) );
      ufdbLogError( "line %d: regular expression error in %s:\n%s   *****", lineno, pattern, errbuf );
  }
  else {
    regexp->substitute = ufdbStrdup( subst );
  }

  if (lastRewrite->rewrite == NULL)
    lastRewrite->rewrite = regexp;
  else 
    lastRewriteRegExec->next = regexp;
  regexp->httpcode = httpcode;
  regexp->global = global;
  lastRewriteRegExec = regexp;
}


struct sgRewrite * sgRewriteFindName( 
  char * name )
{
  struct sgRewrite * p;

  for (p = Rewrite; p != NULL; p = p->next)
  {
    if (strcmp(name,p->name) == 0)
      return p;
  }

  return NULL;
}


/*
 * Time functions
 */

/*
 * sgTime - parse configuration time statement.
 */
void sgTime( 
  char *        name )
{
  struct ufdbTime * t;

  if (UFDBglobalDebug)
     ufdbLogMessage( "sgTime %s", name );

  if (TimeList != NULL)
  {
    if ((struct ufdbTime *) sgTimeFindName(name) != NULL)
    {
      ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
		         lineno, name, UFDBglobalConfigFile );
      ufdbFree( name );
      return;
    }
  }
  else 
    numTimeElements = 0;

  t = (struct ufdbTime *) ufdbMalloc( sizeof(struct ufdbTime) );
  t->name = name;
  t->active = 1;
  t->element = NULL;
  t->next = NULL;

  TimeElement = NULL;
  lastTimeElement = NULL;
  if (TimeList == NULL) 
  {
    TimeList = t;
    lastTime = t;
  }
  else
  {
    lastTime->next = t;
    lastTime = t;
  }
}


/*
 * sgTimeElementInit - initialise parsing of a configuration time element.
 */
void sgTimeElementInit( void )
{
   struct TimeElement * te;

   te = (struct TimeElement *) ufdbCalloc( 1, sizeof(struct TimeElement) );
   numTimeElements++;

   if (lastTime->element == NULL)
     lastTime->element = te;
   if (lastTimeElement != NULL)
     lastTimeElement->next = te;
   lastTimeElement = te;
}


/*
 * sgTimeElementEnd - finalise parsing of configuration time element.
 */
void sgTimeElementEnd( void )
{
  time_switch = 0;
  date_switch = 0;

  if (lastTimeElement->fromdate != 0)
  {
    if (lastTimeElement->todate == 0)
      lastTimeElement->todate = lastTimeElement->fromdate + 86399;
    else 
      lastTimeElement->todate = lastTimeElement->todate + 86399;
  }

  if (lastTimeElement->from == 0  &&  lastTimeElement->to == 0)
    lastTimeElement->to = 1439;  /* set time to 23:59 */
}


/*
 * sgTimeElementAdd - add configuration time element.
 */
void sgTimeElementAdd( 
  char * element, 
  char   type ) 
{
  struct TimeElement * te;
  char * p;
  char   wday;
  int    h, m, Y, M, D;
  time_t sec;
  char * lineptr;

  wday = 0;
  M = 0;
  D = -1;
  te = lastTimeElement;

  switch (type)
  {
  case T_WEEKDAY:
    p = strtok_r( element, " \t,", &lineptr );
    do {
      if (*p == '*') {
	wday = 0x7F;
      } else if (!strncmp(p,"sun",3)) {
	wday = wday | 0x01;
      } else if (!strncmp(p,"mon",3)) {
	wday = wday | 0x02;
      } else if (!strncmp(p,"tue",3)) {
	wday = wday | 0x04;
      } else if (!strncmp(p,"wed",3)) {
	wday = wday | 0x08;
      } else if (!strncmp(p,"thu",3)) {
	wday = wday | 0x10;
      } else if (!strncmp(p,"fri",3)) {
	wday = wday | 0x20;
      } else if (!strncmp(p,"sat",3)) {
	wday = wday | 0x40;
      }
      p = strtok_r( NULL, " \t,", &lineptr );
    } while (p != NULL);
    te->wday = wday;
    break;

  case T_TVAL:
    h = -1;
    m = -1;
    sscanf( element, "%d:%d", &h, &m );
    if ((h < 0 || h > 24) || (m < 0 || m > 59))
    {
      ufdbLogFatalError( "line %d: time format error in %s", lineno, UFDBglobalConfigFile );
      h = 0;
      m = 0;
    }
    if (time_switch == 0) 
    {
      time_switch++;
      te->from = (h * 60) + m ;
    }
    else
    {
      time_switch = 0;
      te->to = (h * 60) + m ;
    }
    break;

  case T_DVAL:
    sec = date2sec( element );
    if (sec == -1) 
    {
      ufdbLogFatalError( "line %d: date format error in %s", lineno, UFDBglobalConfigFile );
      sec = 1;
    }
    if (date_switch == 0) {
      date_switch++;
      te->fromdate = sec;
    } else {
      date_switch = 0;
      te->todate = sec;
    }
    break;

  case T_DVALCRON:
    p = strtok_r( element, "-./", &lineptr );
    Y = atoi(p);
    if (*p == '*')
      Y = -1;
    else
      Y = atoi(p);
    while ((p=strtok_r(NULL,"-./",&lineptr)) != NULL) 
    {
      if (*p == '*')
	if (M == 0)
	  M = -1;
	else 
	  D = -1;
      else
	if (M == 0)
	  M = atoi(p);
	else
	  D = atoi(p);
    }
    te->y = Y;
    te->m = M;
    te->d = D;
    break;

  case T_WEEKLY:
    p = element;
    while (*p != '\0') 
    {
      switch (*p) {
      case 'S':
      case 's':
	wday = wday | 0x01;
	break;
      case 'M':
      case 'm':
	wday = wday | 0x02;
	break;
      case 'T':
      case 't':
	wday = wday | 0x04;
	break;
      case 'W':
      case 'w':
	wday = wday | 0x08;
	break;
      case 'H':
      case 'h':
	wday = wday | 0x10;
	break;
      case 'F':
      case 'f':
	wday = wday | 0x20;
	break;
      case 'A':
      case 'a':
	wday = wday | 0x40;
	break;
      default:
	ufdbLogFatalError( "line %d: weekday format error in %s", lineno, UFDBglobalConfigFile );
	break;
      }
      p++;
    }
    te->wday = wday;
    break;
  }

  ufdbFree( element );
}


/* 
 * lookup a ufdbTime element by name.
 */
struct ufdbTime * sgTimeFindName( 
  char *        name )
{
  struct ufdbTime * p;

  for (p = TimeList; p != NULL; p = p->next)
  {
    if (strcmp(name,p->name) == 0)
      return p;
  }

  return NULL;
}


/*
 * sgTimeCmp - Time array sort function.
 */
static int sgTimeCmp( const void * a, const void * b )
{
   const int * aa = (const int *) a;
   const int * bb = (const int *) b;

   return *aa - *bb;
}


/*
 * getSortedTimeElementTimes - produce a sorted array of time element times
 */
static void getSortedTimeElementTimes( void )
{
   struct ufdbTime *    p;
   struct TimeElement * te;
   int                  i, j;
   int                  totalNumElems;
 
   if (UFDBglobalDebug)
      ufdbLogMessage( "getSortedTimeElementEvents" );

   if (TimeList == NULL)
      return;

   /* find total number of time elements */
   totalNumElems = 0;
   for (p = TimeList;  p != NULL;  p = p->next) 
      for (te = p->element;  te != NULL;  te = te->next) 
         totalNumElems++;

   TimeElementsEvents = (int *) ufdbCalloc( totalNumElems * 2 , sizeof(int) ); 

   i = 0;
   for (p = TimeList;  p != NULL;  p = p->next) 
   {
      for (te = p->element;  te != NULL;  te = te->next) 
      {
         TimeElementsEvents[i++] = te->from == 0 ? 1440 : te->from;
         TimeElementsEvents[i++] = te->to == 0   ? 1440 : te->to;
      }
   }
 
   qsort( TimeElementsEvents, totalNumElems * 2, sizeof(int), sgTimeCmp );

   if (UFDBglobalDebug)
      ufdbLogMessage( "   getSortedTimeElementEvents: after qsort" );

   /* remove identical time elements */
   for (i=1,j=1;  i < totalNumElems * 2;  i++) 
   {
      if (TimeElementsEvents[i] > TimeElementsEvents[i-1])
      {
	 TimeElementsEvents[j] = TimeElementsEvents[i];
         j++;
      }
   }

   numTimeElements = j;			/* #unique time elements */
}


/*
 * _TimeEvaluateElements - evaluate all elements if they match the current time/date and mark them active.
 */
static void _TimeEvaluateElements( 
  struct tm * tm_now, 
  time_t      now )
{
  struct ufdbTime *    tlist;
  struct TimeElement * te;
  int                  min;

  if (UFDBglobalDebug)
     ufdbLogMessage( "_TimeEvaluateElements" );

  for (tlist = TimeList;  tlist != NULL;  tlist = tlist->next)
  {
    tlist->active = 0;
    for (te = tlist->element;  te != NULL;  te = te->next)
    {
      if (te->wday != 0) 			/* check wday */
      {
	if (((1 << tm_now->tm_wday) & te->wday) != 0)  
	{
	  min = (tm_now->tm_hour * 60 ) + tm_now->tm_min;
	  if (min >= te->from  &&  min < te->to) 
	  {
	    tlist->active = 1;
	    break;
	  }
	}
      }
      else if (te->fromdate != 0)		/* check date */
      {
	if (now >= te->fromdate  &&  now <= te->todate) 
	{
	  min = (tm_now->tm_hour * 60 ) + tm_now->tm_min;
	  if (min >= te->from  &&  min < te->to) 
	  {
	    tlist->active = 1;
	    break;
	  }
	}
      }
      else					/* check crondate */
      {
	if (te->y == -1  ||  te->y == (tm_now->tm_year + 1900)) 
	{
	  if (te->m == -1  ||  te->m == (tm_now->tm_mon + 1)) 
	  {
	    if (te->d == -1  ||  te->d == (tm_now->tm_mday)) 
	    {
	      min = (tm_now->tm_hour * 60 ) + tm_now->tm_min;
	      if (min >= te->from  &&  min < te->to) 
	      {
		tlist->active = 1;
		break;
	      }
	    }
	  }
	}
      }
    }
    if (UFDBglobalDebug)
       ufdbLogMessage( "      _TimeEvaluateElements: time %s is %sactive", tlist->name, tlist->active?"":"not " );
  }
}


/*
 * _TimeSetAclSrcDestRew - mark all acl/source/dest/rew (in)active.
 */
static void _TimeSetAclSrcDestRew( void )
{
  struct Acl *         acl;
  struct Category *    cat;
  struct Source *      s;
  struct sgRewrite *   rew;
  int                  a;

  if (UFDBglobalDebug)
     ufdbLogMessage( "_TimeSetAclSrcDestRew" );

  for (acl = AclList;  acl != NULL;  acl = acl->next)
  {
    if (acl->time != NULL  &&  acl->within != UFDB_ACL_ELSE) 
    {
      /* Be careful here: we are multithreaded and other threads use the value 
       * of acl->active at the same time.
       */
      a = acl->time->active;
      if (acl->within == UFDB_ACL_OUTSIDE)
	a = !a;
      if (acl->next != NULL  &&  acl->next->within == UFDB_ACL_ELSE) 
	acl->next->active = !a;
      acl->active = a;
    }
#if 0
    if (acl->pass == NULL)
       acl->active = 0;			/* it can have a 'continue' so do not make it inactive */
#endif
    if (UFDBglobalDebug)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: acl %s %s is %sactive", acl->name, 
		       acl->within==UFDB_ACL_ELSE ? "ELSE" :
			  acl->within==UFDB_ACL_WITHIN ? "WITHIN" :
			     acl->within==UFDB_ACL_OUTSIDE ? "OUTSIDE" : "",
		       acl->active?"":"not " );
  }

  for (cat = Cat;  cat != NULL;  cat = cat->next)
  {
    if (cat->time != NULL) 
    {
      cat->active = cat->time->active;
      if (cat->within == UFDB_ACL_OUTSIDE)
	cat->active = !cat->active;
    }
    if (UFDBglobalDebug)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: category %s is %sactive", cat->name, cat->active?"":"not " );
  }

  for (s = UFDBgetSourceList();  s != NULL;  s = s->next)
  {
    if (s->time != NULL) 
    {
      s->active = s->time->active;
      if (s->within == UFDB_ACL_OUTSIDE)
	s->active = !s->active;
    }
    if (UFDBglobalDebug)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: source %s is %sactive", s->name, s->active?"":"not " );
  }

  for (rew = Rewrite; rew != NULL; rew = rew->next)
  {
    if (rew->time != NULL) 
    {
      rew->active = rew->time->active;
      if (rew->within == UFDB_ACL_OUTSIDE)
	 rew->active = !rew->active;
    }
    if (UFDBglobalDebug)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: rewite %s is %sactive", rew->name, rew->active?"":"not " );
  }
}


/*
 *  ufdbHandleAlarmForTimeEvents - the alarm for the next time event went off so 
 *                                 recalculate the time-dependent active state.
 */
void ufdbHandleAlarmForTimeEvents( 
   int        why )
{
   time_t     now;
   struct tm  tm_now;
   int        m;
   int        tindex;
   int        lastval;

   if (UFDBglobalDebug)
      ufdbLogMessage( "ufdbHandleAlarmForTimeEvents" );

   if (why == UFDB_PARAM_INIT)
      ufdbLogMessage( "time definitions are used; evaluating current ACLs" );
   else
   {
      ufdbLogMessage( "alarm went off to recalculate time ACLs" );
      if (UFDBglobalTerminating)
      {
	 ufdbLogMessage( "This alarm is ignored because ufdbguardd is exiting" );
	 return;
      }
      if (UFDBglobalReconfig)
      {
	 ufdbLogMessage( "This alarm is ignored because the configuration is being reloaded"
	                 " and a new alarm is set to go off in 15 seconds" );
	 alarm( 15 );
	 return;
      }
   }

   if (TimeList == NULL)
   {
      return;
   }

   getSortedTimeElementTimes();

   now = time(NULL) + 30 + globalDebugTimeDelta;
   localtime_r( &now, &tm_now ); 
   m = (tm_now.tm_hour * 60) + tm_now.tm_min;
  
   lastval = 0;
   for (tindex = 0;  tindex < numTimeElements;  tindex++)
   {
#if UFDB_TIME_DEBUG
      if (UFDBglobalDebug)
         ufdbLogMessage( "   TimeElementsEvents[%d] = %d", tindex, TimeElementsEvents[tindex] );
#endif
      lastval = TimeElementsEvents[tindex];
      if (TimeElementsEvents[tindex] >= m)
         break;
   }

   if (UFDBglobalDebug)
      ufdbLogMessage( "   ufdbHandleAlarmForTimeEvents: m = %d  tindex = %d, lastval = %d", m, tindex, lastval );

   if (lastval < m)
      m = (((1440 - m) + TimeElementsEvents[0]) * 60) - tm_now.tm_sec;
   else
      m = ((lastval - m) * 60) - tm_now.tm_sec;

   if (m <= 0)
      m = 30;

   _TimeEvaluateElements( &tm_now, now );
   _TimeSetAclSrcDestRew();

   ufdbFree( TimeElementsEvents );
   TimeElementsEvents = NULL;

   ufdbLogMessage( "next alarm is in %d seconds", (unsigned int) m );
   ufdbSetSignalHandler( SIGALRM, sgAlarm );
   (void) alarm( (unsigned int) m );
}


/*
 * sgTimeElementClone - copy a time specification.
 */
void sgTimeElementClone( void )
{
  struct TimeElement * te;
  struct TimeElement * tmp;

  te = lastTimeElement;
  if (te == NULL) 
  {
    ufdbLogFatalError( "No previous TimeElement in sgTimeElementClone !" );
    return;
  }
  else
  {
    sgTimeElementInit();
    lastTimeElement->wday = te->wday;
    lastTimeElement->from = te->from;
    lastTimeElement->to = te->to;
    lastTimeElement->y = te->y;
    lastTimeElement->m = te->m;
    lastTimeElement->d = te->d;
    lastTimeElement->fromdate = te->fromdate;
    lastTimeElement->todate = te->todate;
    tmp = lastTimeElement;
    lastTimeElement = te;
    sgTimeElementEnd();
    lastTimeElement = tmp;
  }
}


/*
 * IP functions
 */

void sgSetIpType( 
  int         type, 
  char *      file, 
  int         line )
{
  struct Ip * ip;
  char *      p;
  char *      f;
  int         l;
  unsigned int octet;
  unsigned int op;

  ip = sgIpLast( lastSource );
  f = (file == NULL) ? UFDBglobalConfigFile : file;
  l = (line == 0) ? lineno : line;
  if (type == SG_IPTYPE_HOST)
    ip->mask = 0xffffffff;

  if (type == SG_IPTYPE_RANGE)
  {
    if (sgConvDot(ip->str,&op) == NULL)
    {
      ufdbLogFatalError( "IP address error in %s line %d", f, l );
      ip->mask = 0;
    }
    else 
      ip->mask = op;
    if ((unsigned int) ip->net > (unsigned int) ip->mask)
    {
      ufdbLogFatalError( "IP range error in %s line %d   %08x %08x", f, l, ip->net, ip->mask );
    }
  }

  if (type == SG_IPTYPE_CLASS)
  {
    p = ip->str;
    if (*p == '/')
      p++;
    if (sgConvDot(p,&op) == NULL)
    {
      ufdbLogFatalError( "IP address error in %s line %d", f, l );
      ip->mask = 0;
    }
    else 
      ip->mask = op;
  }

  if (type == SG_IPTYPE_CIDR)
  {
    p = ip->str;
    if (*p == '/')
      p++;
    octet = (unsigned long) atoi( p );
    if (octet > 32) 
    {
      ufdbLogFatalError( "IP address CIDR out of range \"%s\" in %s line %d", p, f, l );
      octet = 32;
    }
    if (octet == 32)
      ip->mask = 0xffffffff;
    else
      ip->mask = 0xffffffff ^ (0xffffffff >> octet);
    ip->net = ip->net & ip->mask;
  }

  ip->type = type;
  ip->next = (struct Ip *) ufdbCalloc( 1, sizeof(struct Ip) );

#if 0
  ufdbLogMessage( "   sgSetIpType %2d  %08lx  %08lx", ip->type, ip->net, ip->mask );
#endif

  /* TO-DO: fix messy code where the last struct must contain zeros */
}


void sgIp( 
  const char * name )
{
  struct Ip *  ip;
  unsigned int op;

#if 0
  ufdbLogMessage( "   sgIp( %s )", name );
#endif

  if (lastSource->ip == NULL) 
  {
    ip = (struct Ip *) ufdbCalloc( 1, sizeof(struct Ip) );
#if 0
    ip->str = NULL;
    ip->next = NULL;
#endif
    lastSource->ip = ip;
    lastSource->lastip = ip;
  }
  else
  {
    ip = sgIpLast( lastSource );
  }

  if (ip->net_is_set == 0) 
  {
    ip->net_is_set = 1;
    if (sgConvDot(name,&op) == NULL) 
    {
      ufdbLogFatalError( "line %d: IP address error in %s", lineno, UFDBglobalConfigFile );
      ip->net = 0;
    }
    else 
      ip->net = op;
  }
  else
  {
    ip->str = ufdbStrdup( name );
  }

#if 0
  ufdbLogMessage( "   sgIp %2d  %08lx  %08lx  %s", ip->type, ip->net, ip->mask, ip->str==NULL?"NULL":ip->str );
#endif

}


struct Ip * sgIpLast( 
  struct Source * s )
{
  struct Ip * ip;
  struct Ip * last;

  last = NULL;
  for (ip = s->ip;  ip != NULL;  ip = ip->next)
    last = ip;

  return last;
}


/*
 * ACL functions
 */

void sgAcl( 
   char *          name,
   char *          value, 
   int             within )
{
   struct Acl *    acl;
   struct Source * source;

#if UFDB_DEBUG
   ufdbLogMessage( "sgAcl name=\"%s\" value=\"%s\" within=%d line=%d", 
                   name==NULL?"NULL":name,  value==NULL?"NULL":value, within, lineno );
#endif

   if (AclList != NULL) 
   {
      if (sgAclFindName(name) != NULL)
      {
	 ufdbLogFatalError( "line %d: ACL \"%s\" is already defined in configuration file %s",
			    lineno, name, UFDBglobalConfigFile );
      }
   }

  if (within == UFDB_ACL_ELSE)
  {
     if (lastAcl == NULL)
     {
        ufdbLogFatalError( "line %d: ACL \"else\" has no parent ACL", lineno );
        return;
     }
     if (name == NULL)
        name = ufdbStrdup( lastAcl->name );
  }

  acl = (struct Acl *) ufdbMalloc( sizeof(struct Acl) );

  source = NULL;
  if (strcmp(name,"default") == 0)
  {
    defaultAcl = acl;
  }
  else
  {
    if ((source = defSourceFindName(name)) == NULL)
    {
      ufdbLogFatalError( "line %d: ACL source \"%s\" is not defined in configuration file %s",
		         lineno, name, UFDBglobalConfigFile );
      ufdbFree( name );
      return;
    }
  }

  acl->name = name;
  acl->active = within == UFDB_ACL_ELSE ? 0 : 1;
  acl->source = source;
  acl->pass = NULL;
  acl->implicitPass = NULL;
  acl->hasTerminatorNone = 0;
  acl->rewriteDefault = 1;
  acl->rewrite = NULL;
  acl->redirect = NULL;
  acl->time = NULL;
  acl->within = within;
  acl->next = NULL;

  if (value != NULL) 
  {
    struct ufdbTime * t;
    if ((t = sgTimeFindName(value)) == NULL) 
    {
      ufdbLogFatalError( "line %d: ACL time %s is not defined in configuration file %s",
		         lineno, value, UFDBglobalConfigFile );
      return;
    }
    acl->time = t;
  }

  if (AclList == NULL) 
  {
    AclList = acl;
    lastAcl = acl;
  }
  else
  {
    lastAcl->next = acl;
    lastAcl = acl;
  }
}


void sgAclSetValue( 
  const char *         what,
  char *               value, 
  int                  allowed ) 
{
  struct Category *    cat = NULL;
  struct AclCategory * aclcat;
  int                  type;
  
#if UFDB_DEBUG
   ufdbLogMessage( "sgAclSetValue %s %s%s", what, allowed?"":"!", value );
#endif

  if (lastAcl == NULL)
  {
     ufdbLogError( "error in configuration file on line %d: cannot set value for \"%s\" because there is no defined ACL", 
                   lineno, what );
     ufdbFree( value );
     return;
  }

  type = ACL_TYPE_TERMINATOR;

  if (strcmp(what,"pass") == 0)
  {
    if (strcmp(value,"any")==0 || strcmp(value,"all")==0)
    {
       if (!allowed)
          ufdbLogFatalError( "error in configuration file on line %d: do not use '!any' or '!all'.  Use 'none' instead.", lineno );
       allowed = 1;
    }
    else if (strcmp(value,"none") == 0)
    {
       if (!allowed)
          ufdbLogFatalError( "error in configuration file on line %d: do not use '!none'.  Use 'any' instead.", lineno );
       allowed = 0;
    }
    else if (strcmp(value,"in-addr") == 0) {
      type = ACL_TYPE_INADDR;
    }
    else
    {
      if ((cat = ufdbCategoryFindName(value)) == NULL) 
      {
	ufdbLogFatalError( "ACL category \"%s\" (line %d) is not defined in configuration file %s",
			   value, lineno, UFDBglobalConfigFile );
	ufdbFree( value );
        return;
      } 
      type = ACL_TYPE_DEFAULT;
    }

    aclcat = (struct AclCategory *) ufdbMallocAligned( 64, sizeof(struct AclCategory) );
    aclcat->name = value;
    aclcat->cat = cat;
    aclcat->access = allowed;
    aclcat->type = type;
    aclcat->next = NULL;
    aclcat->nblocks = 0;
    aclcat->nmatches = 0;

    if (lastAcl->pass == NULL) {
      lastAcl->pass = aclcat;
    } else {
      lastAclCategory->next = aclcat;
    }
    lastAclCategory = aclcat;
  }
  else if (strcmp(what,"redirect") == 0)
  {
    if (strcmp(value,"default") != 0)
    {
      lastAcl->redirect = value;
    }
    else 
    {
      lastAcl->redirect = NULL;
      ufdbFree( value );
    }
  }
  else if (strcmp(what,"rewrite") == 0)
  {
    if (strcmp(value,"none") == 0)
    {
      lastAcl->rewriteDefault = 0;
      lastAcl->rewrite = NULL;
    }
    else
    {
      struct sgRewrite * rewrite;

      if ((rewrite = sgRewriteFindName(value)) == NULL) 
      {
	ufdbLogFatalError( "rewrite %s is not defined in configuration file %s",
			   value, UFDBglobalConfigFile );
      }
      lastAcl->rewriteDefault = 0;
      lastAcl->rewrite = rewrite;
    }
    ufdbFree( value );
  }
}


struct Acl * sgAclFindName( 
  char *       name )
{
  struct Acl * p;

  if (name == NULL)
     return NULL;

  for (p = AclList;  p != NULL;  p = p->next)
  {
    if (strcmp(name,p->name) == 0)
      return p;
  }

  return NULL;
}


void yyerror( char * s )
{
   ufdbLogFatalError( "line %d: %s in configuration file %s", lineno, s, UFDBglobalConfigFile );
}


int yywrap()
{
  return 1;
}

